import { EventEmitter } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder, FormGroup, FormControl } from '@angular/forms';
import { CollectionView } from 'wijmo/wijmo';
import { ModalDirective } from 'ngx-bootstrap';
import { Context } from 'framework3/core';
import { AlertsBarComponent, AzComboboxComponent } from 'framework3/controls';
import { DeudorService } from '../services/deudor.service';
import { CajaService } from '../services/caja.service';
import { CajaItem } from '../models/caja';
import { FormaPagoItem } from '../models/forma-pago';
import { CobranzaFormaPagoDetail, FormaPagoDetail } from '../models/forma-pago-detail';
import { FormaPagoService } from '../services/forma-pago.service';
import { FormaPagoService as FormaPagoBaseService } from '../../accounting/services/forma-pago.service';
import { CuentaBancariaItem } from '../../accounting/models/cuenta-bancaria';
import { CuentaBancariaService } from '../../accounting/services/cuenta-bancaria.service';
export declare class CobranzaComponent {
    private formBuilder;
    private context;
    private router;
    private route;
    private formaPagoService;
    private formaPagoBaseService;
    private cajaService;
    private deudorService;
    private cuentaBancariaService;
    title: string;
    editorForm: FormGroup;
    formasPago: FormaPagoItem[];
    cajas: CajaItem[];
    cuentasBeneficiario: CuentaBancariaItem[];
    idCaja: number;
    formasPagoCobro: CollectionView;
    solicitado: number;
    recibido: number;
    cambio: number;
    saldo: number;
    cajaVisible: boolean;
    formaPagoDet: FormaPagoDetail;
    idFormaPago: number;
    allReference: boolean;
    regExpCuentaOrdenante: string;
    regExpCuentaBeneficiario: string;
    cobroAcceptado: EventEmitter<CobranzaFormaPagoDetail>;
    idCuentaBeneficiario: number;
    cuentaBeneficiarioFija: boolean;
    alerts: AlertsBarComponent;
    dlgCobranza: ModalDirective;
    cboFormaPago: AzComboboxComponent;
    constructor(formBuilder: FormBuilder, context: Context, router: Router, route: ActivatedRoute, formaPagoService: FormaPagoService, formaPagoBaseService: FormaPagoBaseService, cajaService: CajaService, deudorService: DeudorService, cuentaBancariaService: CuentaBancariaService);
    ngAfterViewInit(): void;
    validateCuentaOrdenante(regExpCuentaOrdenante: string, control: FormControl): string;
    validateCuentaBeneficiario(regExpCuentaBeneficiario: string, control: FormControl): string;
    showSinCaja(totalSolicitado: number, idCaja: number, idDeudor: number): void;
    show(totalSolicitado: number, idDeudor: number): void;
    clear(): void;
    loadFormasPago(): void;
    loadCajas(): void;
    loadCuentasBeneficiario(): void;
    selectedFormaPagoChanged(idFormaPago: number): void;
    addDetail(): void;
    resetFormaPago(): void;
    validateFormaPago(): boolean;
    calculaTotales(): void;
    onFormaPagoDelete(item: FormaPagoDetail): void;
    accept(): void;
    discardChanges(): void;
    showAlert(message: string, type: string): void;
}
