"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
//import { RegExp } from "typescript-dotnet-commonjs/System/Text/RegularExpressions";
//import { RegExp } from "RegularExpressions/Regex"; //
//
//features
var wijmo_1 = require("wijmo/wijmo");
var ngx_bootstrap_1 = require("ngx-bootstrap");
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
//
var deudor_service_1 = require("../services/deudor.service");
var caja_service_1 = require("../services/caja.service");
var forma_pago_detail_1 = require("../models/forma-pago-detail");
var forma_pago_service_1 = require("../services/forma-pago.service");
var forma_pago_service_2 = require("../../accounting/services/forma-pago.service");
var cuenta_bancaria_service_1 = require("../../accounting/services/cuenta-bancaria.service");
var CobranzaComponent = /** @class */ (function () {
    function CobranzaComponent(formBuilder, context, router, route, formaPagoService, formaPagoBaseService, cajaService, deudorService, cuentaBancariaService) {
        var _this = this;
        this.formBuilder = formBuilder;
        this.context = context;
        this.router = router;
        this.route = route;
        this.formaPagoService = formaPagoService;
        this.formaPagoBaseService = formaPagoBaseService;
        this.cajaService = cajaService;
        this.deudorService = deudorService;
        this.cuentaBancariaService = cuentaBancariaService;
        this.title = '';
        this.formasPago = [];
        this.cajas = [];
        this.cuentasBeneficiario = [];
        this.idCaja = 0;
        this.formasPagoCobro = new wijmo_1.CollectionView();
        this.solicitado = 0;
        this.recibido = 0;
        this.cambio = 0;
        this.saldo = 0;
        this.cajaVisible = true;
        this.formaPagoDet = new forma_pago_detail_1.FormaPagoDetail();
        //codeAccounting: string = "";
        this.idFormaPago = 0;
        //monto: number=0;
        //referencia: string = "";
        //idBanco: number = 0;
        //cuenta: string = "";
        //fecha: Date;
        this.allReference = false;
        this.regExpCuentaOrdenante = "[0-9]{11}|[0-9]{18}";
        this.regExpCuentaBeneficiario = "[0-9]{11}|[0-9]{18}";
        this.cobroAcceptado = new core_1.EventEmitter();
        this.idCuentaBeneficiario = 0;
        this.cuentaBeneficiarioFija = false;
        this.editorForm = formBuilder.group({
            'idCaja': ['', forms_1.Validators.required],
            'totalMonto': [''],
            'totalRecibido': [''],
            'totalCambio': [''],
            'formaPago': [''],
            'monto': [''],
            'referencia': [''],
            'banco': [''],
            'cuentaOrd': ['', function (control) { return _this.validateCuentaOrdenante(_this.regExpCuentaOrdenante, control); }],
            'cuentaBenef': [0, forms_1.Validators.required],
            'rfcOrdenante': ['', forms_1.Validators.pattern("^([A-ZÑ\x26]{3,4}([0-9]{2})(0[1-9]|1[0-2])(0[1-9]|1[0-9]|2[0-9]|3[0-1])([A-Z]|[0-9]){2}([A]|[0-9]){1})?$")],
            'rfcBeneficiario': ['', forms_1.Validators.pattern("^([A-ZÑ\x26]{3,4}([0-9]{2})(0[1-9]|1[0-2])(0[1-9]|1[0-9]|2[0-9]|3[0-1])([A-Z]|[0-9]){2}([A]|[0-9]){1})?$")],
            'fecha': [''],
        });
        this.formaPagoDet = new forma_pago_detail_1.FormaPagoDetail();
    }
    CobranzaComponent.prototype.ngAfterViewInit = function () {
        //setTimeout(_ => this.loadOptions());
        this.formaPagoDet = new forma_pago_detail_1.FormaPagoDetail();
    };
    CobranzaComponent.prototype.validateCuentaOrdenante = function (regExpCuentaOrdenante, control) {
        var pattern = forms_1.Validators.pattern(regExpCuentaOrdenante);
        //let pattern = Validators.pattern(regExpCuentaOrdenante);          
        if (control.value == undefined)
            return null;
        if (control.value.match(regExpCuentaOrdenante))
            //if (pattern.isMatch(control.value))
            return null;
        else
            return 'Cuenta no válida';
    };
    CobranzaComponent.prototype.validateCuentaBeneficiario = function (regExpCuentaBeneficiario, control) {
        if (control.value == undefined)
            return null;
        if (control.value.match(regExpCuentaBeneficiario))
            //if (pattern.isMatch(control.value))
            return null;
        else
            return 'Cuenta no válida';
    };
    CobranzaComponent.prototype.showSinCaja = function (totalSolicitado, idCaja, idDeudor) {
        this.cajaVisible = true;
        if (idCaja > 0) {
            this.cajaVisible = false;
            this.idCaja = idCaja;
        }
        this.show(totalSolicitado, idDeudor);
    };
    CobranzaComponent.prototype.show = function (totalSolicitado, idDeudor) {
        var _this = this;
        if (totalSolicitado != undefined) {
            this.solicitado = totalSolicitado;
            this.saldo = totalSolicitado;
        }
        this.allReference = false;
        if (idDeudor > 0) {
            this.deudorService.getDetailFromCache(idDeudor)
                .then(function (deudor) {
                if (deudor.idFormaPago > 0) {
                    _this.idFormaPago = deudor.idFormaPago;
                    _this.selectedFormaPagoChanged(_this.idFormaPago);
                }
                //Si el deudor tiene una clasificacion con el codigo COB_FP_REF  es porque maneja que algunos deudores exigen que se les muestre todas las referencias a la forma de pago
                var clasificacionReferenciasFormaPago = deudor.clasificaciones.find(function (clas) { return clas.codigoGrupo == 'COB_FP_REF'; });
                if (clasificacionReferenciasFormaPago != null)
                    _this.allReference = (clasificacionReferenciasFormaPago.valor == '1') ? true : false;
            })
                .catch(function (error) { return _this.showAlert(error.message, 'danger'); });
        }
        this.dlgCobranza.config.backdrop = false;
        this.loadFormasPago();
        this.loadCajas();
        this.loadCuentasBeneficiario();
        this.dlgCobranza.show();
    };
    CobranzaComponent.prototype.clear = function () {
        this.formasPagoCobro = new wijmo_1.CollectionView();
        this.solicitado = 0;
        this.recibido = 0;
        this.cambio = 0;
    };
    CobranzaComponent.prototype.loadFormasPago = function () {
        var _this = this;
        this.formaPagoService.loadList(this.context.app.defaultSite.identity)
            .then(function (formasPago) { return _this.formasPago = formasPago; })
            .catch(function (error) { return _this.showAlert(error.message, 'danger'); });
    };
    CobranzaComponent.prototype.loadCajas = function () {
        var _this = this;
        this.cajaService.loadListByUser(this.context.app.defaultSite.identity)
            .then(function (cajas) {
            _this.cajas = cajas;
        })
            .catch(function (error) { return _this.showAlert(error, 'danger'); });
    };
    CobranzaComponent.prototype.loadCuentasBeneficiario = function () {
        var _this = this;
        this.cuentaBancariaService.loadListByUser(this.context.app.defaultSite.identity)
            .then(function (cuentasBeneficiario) {
            _this.cuentasBeneficiario = cuentasBeneficiario;
        })
            .catch(function (error) { return _this.showAlert(error, 'danger'); });
    };
    CobranzaComponent.prototype.selectedFormaPagoChanged = function (idFormaPago) {
        var _this = this;
        this.formaPagoDet = new forma_pago_detail_1.FormaPagoDetail();
        this.formaPagoDet.fecha.setHours(0);
        this.formaPagoDet.fecha.setMinutes(0);
        this.formaPagoDet.fecha.setSeconds(0);
        this.formaPagoDet.fecha.setMilliseconds(0);
        this.formaPagoDet.monto = this.saldo;
        this.formaPagoDet.idFormaPago = idFormaPago;
        this.formaPagoService.getDetailByID(idFormaPago)
            .then(function (formaPago) {
            _this.formaPagoDet.formaPago = formaPago;
            _this.regExpCuentaOrdenante = formaPago.formaPagoBase.regExpCuentaOrdenante;
            _this.regExpCuentaBeneficiario = formaPago.formaPagoBase.regExpCuentaBeneficiario;
        })
            .catch(function (error) { return _this.showAlert(error.message, 'danger'); });
        if (this.idCuentaBeneficiario > 0) {
            this.formaPagoDet.idCuentaBeneficiario = this.idCuentaBeneficiario;
            this.cuentaBeneficiarioFija = true;
        }
        this.validateFormaPago();
    };
    CobranzaComponent.prototype.addDetail = function () {
        var _this = this;
        var cambioLocal = 0;
        var newFormasPago = this.formasPagoCobro.sourceCollection.slice();
        //Vefificamos que no se haya capturado esta misma forma de pago antes. Si asi es, la acumulamos
        var formaPagoExist = newFormasPago.find(function (search) { return search.idFormaPago == _this.formaPagoDet.idFormaPago && search.referencia == _this.formaPagoDet.referencia; });
        if (this.recibido + this.formaPagoDet.monto > this.solicitado && this.formaPagoDet.formaPago.formaPagoBase.code != "01") //Solo el efectivo regresa cambio  -- Configurar.  Ver cuales piden fecha y cuales piden banco porque la tarjeta no deberia      
            this.showAlert("Esta forma de pago no admite cambio", "danger");
        else {
            cambioLocal = (this.recibido + this.formaPagoDet.monto) - this.solicitado;
            if (cambioLocal < 0)
                cambioLocal = 0;
            if (formaPagoExist == undefined) {
                this.formaPagoDet.cambio = cambioLocal;
                newFormasPago.push(this.formaPagoDet);
                this.formaPagoDet = new forma_pago_detail_1.FormaPagoDetail();
            }
            else
                formaPagoExist.monto += this.formaPagoDet.monto;
            this.formasPagoCobro.sourceCollection = newFormasPago;
            this.resetFormaPago();
            this.calculaTotales();
        }
    };
    CobranzaComponent.prototype.resetFormaPago = function () {
        this.formaPagoDet = new forma_pago_detail_1.FormaPagoDetail();
        this.validateFormaPago();
    };
    CobranzaComponent.prototype.validateFormaPago = function () {
        if (this.formaPagoDet.formaPago.identity == 0 || this.formaPagoDet.monto == 0)
            return false;
        //else if (this.formaPagoDet.formaPago.formaPagoBase.bancarizado && this.formaPagoDet.idBanco == 0)
        //    return false;
        else if (this.formaPagoDet.formaPago.formaPagoBase.cuentaOrdenante && this.formaPagoDet.cuentaOrdenante.trim() == "")
            return false;
        else if (this.formaPagoDet.formaPago.formaPagoBase.cuentaBeneficiario && (this.formaPagoDet.idCuentaBeneficiario == 0 || this.formaPagoDet.idCuentaBeneficiario == undefined))
            return false;
        else if (this.formaPagoDet.formaPago.formaPagoBase.requiereNumOperacion && this.formaPagoDet.numeroOperacion.trim() == "")
            return false;
        return true;
    };
    CobranzaComponent.prototype.calculaTotales = function () {
        this.recibido = 0;
        this.cambio = 0;
        this.recibido = this.formasPagoCobro.sourceCollection
            .map(function (c) { return c.monto; })
            .reduce(function (sum, current) { return sum + current; });
        if (this.recibido > this.solicitado)
            this.cambio = this.recibido - this.solicitado;
        else
            this.saldo = this.solicitado - this.recibido;
    };
    CobranzaComponent.prototype.onFormaPagoDelete = function (item) {
        this.formasPagoCobro.remove(item);
        this.calculaTotales();
    };
    CobranzaComponent.prototype.accept = function () {
        var cobranza = new forma_pago_detail_1.CobranzaFormaPagoDetail();
        cobranza.idCaja = this.idCaja;
        cobranza.FormaPagoDetail = this.formasPagoCobro.sourceCollection;
        this.cobroAcceptado.emit(cobranza);
        this.dlgCobranza.hide();
    };
    CobranzaComponent.prototype.discardChanges = function () {
        this.dlgCobranza.hide();
    };
    CobranzaComponent.prototype.showAlert = function (message, type) {
        this.alerts.showAlert(message, type);
    };
    __decorate([
        core_1.Output(),
        __metadata("design:type", core_1.EventEmitter)
    ], CobranzaComponent.prototype, "cobroAcceptado", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], CobranzaComponent.prototype, "idCuentaBeneficiario", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], CobranzaComponent.prototype, "alerts", void 0);
    __decorate([
        core_1.ViewChild('dlgCobranza'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], CobranzaComponent.prototype, "dlgCobranza", void 0);
    __decorate([
        core_1.ViewChild('cboFormaPago'),
        __metadata("design:type", controls_1.AzComboboxComponent)
    ], CobranzaComponent.prototype, "cboFormaPago", void 0);
    CobranzaComponent = __decorate([
        core_1.Component({
            selector: 'credit-cobranza',
            template: "\n\n      <div bsModal #dlgCobranza=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myLargeModalLabel\" aria-hidden=\"true\">\n          <div class=\"modal-dialog modal-lg\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-body\">\n\n                      <form [formGroup]=\"editorForm\">\n\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <alerts-bar></alerts-bar>\n                              </div>\n                          </div>\n\n                          <div class=\"row\">\n                              <div class=\"col-12 col-md-6\">\n                                  <azteca-form-field [label]=\"'Caja:'\" *ngIf=\"cajaVisible\">\n                                      <az-combobox formControlName=\"idCaja\"\n                                                   [(ngModel)]=\"idCaja\"\n                                                   [items]=\"cajas\"\n                                                   [valueMember]=\"'id'\"\n                                                   [displayMember]=\"'nombre'\">\n                                      </az-combobox>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <az-panel [header]=\"'Totales'\" type=\"success\">\n                                      <div class=\"row\">\n                                          <div class=\"col-12 col-md-6\">\n                                              <az-label text=\"Solicitado\"></az-label>\n                                          </div>\n                                          <div class=\"col-12 col-md-6\">\n                                              <az-input-number formControlName=\"totalMonto\" [(ngModel)]=\"solicitado\" format=\"N2\" enabled=\"false\"></az-input-number>\n                                          </div>\n                                      </div>\n                                      <div class=\"row\">\n                                          <div class=\"col-12 col-md-6\">\n                                              <az-label text=\"Recibido\"></az-label>\n                                          </div>\n                                          <div class=\"col-12 col-md-6\">\n                                              <az-input-number formControlName=\"totalRecibido\" [(ngModel)]=\"recibido\" format=\"N2\" enabled=\"false\"></az-input-number>\n                                          </div>\n                                      </div>\n                                      <div class=\"row\">\n                                          <div class=\"col-12 col-md-6\">\n                                              <az-label text=\"Cambio\"></az-label>\n                                          </div>\n                                          <div class=\"col-12 col-md-6\">\n                                              <az-input-number formControlName=\"totalCambio\" [(ngModel)]=\"cambio\" format=\"N2\" enabled=\"false\"></az-input-number>\n                                          </div>\n                                      </div>\n                                  </az-panel>\n                        \n\n                                  <az-panel [header]=\"'Agregar Forma de pago'\" type=\"success\">\n\n                                      <div class=\"row\">\n\n                                          <div class=\"col-12 col-lg-4\">\n                                              <azteca-form-field [label]=\"'Forma de pago'\">\n                                                  <az-combobox #cboFormaPago\n                                                               formControlName=\"formaPago\"\n                                                               [(ngModel)]=\"idFormaPago\"\n                                                               [items]=\"formasPago\"\n                                                               [displayMember]=\"'nombre'\"\n                                                               [valueMember]=\"'id'\"\n                                                               (selectedItemChanged)=\"selectedFormaPagoChanged($event)\">\n                                                  </az-combobox>\n                                              </azteca-form-field>\n                                          </div>\n\n                                          <div class=\"col-12 col-lg-3\">\n                                              <azteca-form-field [label]=\"'Monto'\">\n                                                  <az-input-number formControlName=\"monto\" [(ngModel)]=\"formaPagoDet.monto\" format=\"N2\"></az-input-number>\n                                              </azteca-form-field>\n                                          </div>\n\n                                          <div class=\"col-12 col-lg-3\">\n                                              <azteca-form-field [label]=\"'Referencia(opcional)'\">\n                                                  <az-textbox formControlName=\"referencia\" [(ngModel)]=\"formaPagoDet.referencia\"></az-textbox>\n                                              </azteca-form-field>\n                                          </div>\n\n                                          <div class=\"col-12 col-lg-2\">\n                                              <button type=\"submit\" class=\"btn btn-primary\" (click)=\"addDetail()\" [disabled]=\"!validateFormaPago()\">\n                                                  <span class=\"glyphicon glyphicon-plus\" aria-hidden=\"true\"></span> Agregar\n                                              </button>\n                                          </div>\n                                      </div>\n\n                                      <div class=\"row\">\n                                          <div class=\"col-12 col-lg-3\">\n                                              <azteca-form-field [label]=\"'Fecha:'\">\n                                                  <az-input-date formControlName=\"fecha\" [(ngModel)]=\"formaPagoDet.fecha\"></az-input-date>\n                                              </azteca-form-field>\n                                          </div>\n                                          <div class=\"col-12 col-lg-3\">\n                                              <azteca-form-field [label]=\"'Banco:'\" *ngIf=\"formaPagoDet.formaPago.formaPagoBase.bancarizado || allReference\">\n                                                  <accounting-banco-selector formControlName=\"banco\" [(ngModel)]=\"formaPagoDet.idBanco\" [showListButton]=\"false\"></accounting-banco-selector>\n                                              </azteca-form-field>\n                                          </div>\n                                          <div class=\"col-12 col-lg-3\">\n                                              <azteca-form-field [label]=\"'#Cuenta Ordenante'\" *ngIf=\"formaPagoDet.formaPago.formaPagoBase.cuentaOrdenante || allReference\">\n                                                  <az-textbox formControlName=\"cuentaOrd\" [(ngModel)]=\"formaPagoDet.cuentaOrdenante\"></az-textbox>\n                                              </azteca-form-field>\n                                          </div>\n\n                                          <div class=\"col-12 col-lg-3\">\n                                              <azteca-form-field [label]=\"'RFC Ordenante'\" *ngIf=\"formaPagoDet.formaPago.formaPagoBase.rfcOrdenante || allReference\">\n                                                  <az-textbox formControlName=\"rfcOrdenante\" [(ngModel)]=\"formaPagoDet.rfcOrdenante\">{{value | uppercase}}</az-textbox>\n                                              </azteca-form-field>\n                                          </div>\n                                      </div>\n\n                                      <div class=\"row\">\n                                          <div class=\"col-12 col-lg-4\">\n                                              <azteca-form-field [label]=\"'#Cuenta Beneficiario'\" *ngIf=\"formaPagoDet.formaPago.formaPagoBase.cuentaBeneficiario || allReference\">\n                                                  <az-combobox #cboCuentasBeneficiario\n                                                                  [enabled]=\"!cuentaBeneficiarioFija\"\n                                                                  formControlName=\"cuentaBenef\"\n                                                                  [(ngModel)]=\"formaPagoDet.idCuentaBeneficiario\"\n                                                                  [items]=\"cuentasBeneficiario\"\n                                                                  [displayMember]=\"'nombre'\"\n                                                                  [valueMember]=\"'id'\">\n                                                  </az-combobox>\n                                              </azteca-form-field>\n                                          </div>\n                                          <div class=\"col-12 col-lg-3\">\n                                              <azteca-form-field [label]=\"'RFC Beneficiario'\" *ngIf=\"formaPagoDet.formaPago.formaPagoBase.rfcBeneficiario || allReference\">\n                                                  <az-textbox formControlName=\"rfcBeneficiario\" [(ngModel)]=\"formaPagoDet.rfcBeneficiario\">{{formaPagoDet.rfcBeneficiario | uppercase}}</az-textbox>\n                                              </azteca-form-field>\n                                          </div>                                       \n                                      </div>\n\n                                      <div class=\"row\">\n                                          <div class=\"col-12 col-lg-3\">\n                                              <azteca-form-field [label]=\"'#No Operacion'\" *ngIf=\"formaPagoDet.formaPago.formaPagoBase.requiereNumeroOperacion || allReference\">\n                                                  <az-textbox formControlName=\"referencia\" [(ngModel)]=\"formaPagoDet.numeroOperacion\"></az-textbox>\n                                              </azteca-form-field>\n                                          </div>\n                                      </div>\n                                                                \n                                  </az-panel>\n\n                                  <az-panel [header]=\"'Detalle'\" type=\"success\">\n\n                                      <wj-flex-grid style=\"height:300px\" [itemsSource]=\"formasPagoCobro\" [isReadOnly]=\"true\">\n\n                                          <wj-flex-grid-column [header]=\"''\" [width]=\"55\" [isReadOnly]=\"true\">\n                                              <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                                  <button type=\"button\" class=\"btn btn-default\" (click)=\"onFormaPagoDelete(cell.item)\">\n                                                      <span class=\"glyphicon glyphicon-trash\"></span>\n                                                  </button>\n                                              </ng-template>\n                                          </wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Forma Pago'\" [binding]=\"'formaPago.formaPagoBase.nombre'\" [width]=\"'50*'\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Monto'\" [binding]=\"'monto'\" [width]=\"'10*'\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Cambio'\" [binding]=\"'cambio'\" [width]=\"'10*'\"></wj-flex-grid-column>\n                                          <wj-flex-grid-column [header]=\"'Referencia'\" [binding]=\"'referencia'\" [width]=\"'10*'\"></wj-flex-grid-column>\n\n                                      </wj-flex-grid>\n\n                                  </az-panel>\n\n\n                              </div> <!--Modal Body-->\n\n\n\n\n                              <div class=\"modal-footer\">\n                                  <button type=\"button\" class=\"btn btn-primary\" (click)=\"accept()\" [disabled]=\"solicitado!=recibido-cambio\">Aceptar</button>\n                                  <button type=\"button\" class=\"btn btn-default\" (click)=\"discardChanges()\">Descartar</button>\n                           \n                              </div>\n                          </div> <!--Modal Footer-->\n\n\n\n                      </form>\n\n                  </div>\n              </div> <!-- Modal Content-->\n          </div> <!--Modal-->\n      </div> <!--Modal directive-->\n    "
        }),
        __metadata("design:paramtypes", [forms_1.FormBuilder, core_2.Context, router_1.Router, router_1.ActivatedRoute, forma_pago_service_1.FormaPagoService,
            forma_pago_service_2.FormaPagoService, caja_service_1.CajaService, deudor_service_1.DeudorService, cuenta_bancaria_service_1.CuentaBancariaService])
    ], CobranzaComponent);
    return CobranzaComponent;
}());
exports.CobranzaComponent = CobranzaComponent;
