import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogEditor, EditorEventArgs } from 'framework3/editors';
import { CategoriasPresupuestalesService } from '../services/categorias-presupuestales.service';
import { CategoriasPresupuestalesInfo } from '../models/categorias-presupuestales';
import { ArticuloInfo } from '..';
import { ServicioInfo } from '..';
export declare class CategoriasPresupuestalesEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private categoriasPresupuestalesService;
    categoriasPresupuestales: CategoriasPresupuestalesInfo;
    articulos: ArticuloInfo[];
    articulosEliminados: ArticuloInfo[];
    servicios: ServicioInfo[];
    serviciosEliminados: ServicioInfo[];
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, categoriasPresupuestalesService: CategoriasPresupuestalesService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onSelectedArticulos(args: any): void;
    onDeletedArticulo(args: any): void;
    onDeletedServicio(args: any): void;
    onSelectedServicios(args: any): void;
}
