"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var categorias_presupuestales_service_1 = require("../services/categorias-presupuestales.service");
var categorias_presupuestales_1 = require("../models/categorias-presupuestales");
var CategoriasPresupuestalesEditor = /** @class */ (function (_super) {
    __extends(CategoriasPresupuestalesEditor, _super);
    //
    function CategoriasPresupuestalesEditor(router, route, formBuilder, changeDetector, context, location, categoriasPresupuestalesService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.categoriasPresupuestalesService = categoriasPresupuestalesService;
        _this.categoriasPresupuestales = new categorias_presupuestales_1.CategoriasPresupuestalesInfo();
        _this.articulos = [];
        _this.articulosEliminados = [];
        _this.servicios = [];
        _this.serviciosEliminados = [];
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'idCuenta': ['', forms_1.Validators.required],
        });
        return _this;
    }
    CategoriasPresupuestalesEditor_1 = CategoriasPresupuestalesEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    CategoriasPresupuestalesEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
    };
    CategoriasPresupuestalesEditor.prototype.onCreatingItem = function () {
    };
    CategoriasPresupuestalesEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.categoriasPresupuestalesService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.categoriasPresupuestales = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CategoriasPresupuestalesEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.categoriasPresupuestalesService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.categoriasPresupuestales = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CategoriasPresupuestalesEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.categoriasPresupuestalesService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.categoriasPresupuestales = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    CategoriasPresupuestalesEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        var categoriaPresupuestalSave = new categorias_presupuestales_1.CategoriaPresupuestal();
        this.categoriasPresupuestales.idBranch = this.context.app.defaultSite.identity;
        this.categoriasPresupuestales.idCompany = this.context.app.defaultCompany.identity;
        categoriaPresupuestalSave.categoriaPresupuestal = this.categoriasPresupuestales;
        categoriaPresupuestalSave.articulos = this.articulos;
        categoriaPresupuestalSave.articulosEliminados = this.articulosEliminados;
        categoriaPresupuestalSave.servicios = this.servicios;
        categoriaPresupuestalSave.serviciosEliminados = this.serviciosEliminados;
        console.log(JSON.stringify(categoriaPresupuestalSave));
        this.categoriasPresupuestalesService.updateCategoria(categoriaPresupuestalSave)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.categoriasPresupuestales.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.categoriasPresupuestales = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    //searchArticuloRequested(request: SearchRequest) {
    //    this.articulo = request;
    //    this.refreshListArticulios();
    //}
    CategoriasPresupuestalesEditor.prototype.onSelectedArticulos = function (args) {
        this.articulos = args;
    };
    CategoriasPresupuestalesEditor.prototype.onDeletedArticulo = function (args) {
        this.articulosEliminados = args;
    };
    CategoriasPresupuestalesEditor.prototype.onDeletedServicio = function (args) {
        this.serviciosEliminados = args;
    };
    CategoriasPresupuestalesEditor.prototype.onSelectedServicios = function (args) {
        this.servicios = args;
    };
    var CategoriasPresupuestalesEditor_1;
    CategoriasPresupuestalesEditor = CategoriasPresupuestalesEditor_1 = __decorate([
        core_1.Component({
            selector: 'compras-categorias-presupuestales-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor\n                                 [title]=\"'CategoriasPresupuestales'\"\n                                 [info]=\"categoriasPresupuestales\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <!------------------- Controles del editor ----------------------------->\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"categoriasPresupuestales.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"categoriasPresupuestales.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Cuenta:'\">\n                          <accounting-cuenta-selector formControlName=\"idCuenta\" [(ngModel)]=\"categoriasPresupuestales.idCuenta\"></accounting-cuenta-selector>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Articulos \">\n                              <categorias-presupuestales-articulos [idCategoriaPresupuestal]=\"categoriasPresupuestales.identity\" (articulosSelected)=\"onSelectedArticulos($event)\" (articulosDeleted)=\"onDeletedArticulo($event)\"></categorias-presupuestales-articulos>                       \n                          </tab>\n                          <tab heading=\"Servicios\"> \n                              <categorias-presupuestales-servicios [idCategoriaPresupuestal]=\"categoriasPresupuestales.identity\" (servicioSelected)=\"onSelectedServicios($event)\" (servicioDeleted)=\"onDeletedServicio($event)\"></categorias-presupuestales-servicios>\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n\n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return CategoriasPresupuestalesEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: categorias_presupuestales_service_1.CategoriasPresupuestalesService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, categorias_presupuestales_service_1.CategoriasPresupuestalesService])
    ], CategoriasPresupuestalesEditor);
    return CategoriasPresupuestalesEditor;
}(editors_1.CatalogEditor));
exports.CategoriasPresupuestalesEditor = CategoriasPresupuestalesEditor;
