import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogEditor, EditorEventArgs } from 'framework3/editors';
import { ProveedorService } from '../services/proveedor.service';
import { ProveedorInfo } from '../models/proveedor';
import { ArticuloService } from '../services/articulo.service';
export declare class ProveedoresEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private proveedorService;
    private articuloSvc;
    proveedor: ProveedorInfo;
    tiposProveedor: any[];
    proceso: number;
    idProveedor: number;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, proveedorService: ProveedorService, articuloSvc: ArticuloService);
    ngOnInit(): void;
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onAgregarArticulo(): void;
    onAgregarServicio(): void;
    refreshControls(): void;
}
