import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { ToolbarButton } from 'framework3/controls';
import { CatalogEditor, EditorEventArgs, TrackableCollection } from 'framework3/editors';
import { ServicioService } from '../services/servicio.service';
import { ServicioInfo } from '../models/servicio';
import { ImpuestoAsignacionInfo } from '../../accounting/models/impuesto-asignacion';
import { ImpuestosAsignacionEditor } from '../../accounting/components/impuesto-asignacion.editor';
export declare class ServiciosEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private servicioService;
    servicio: ServicioInfo;
    proceso: number;
    servicioImpuestos: ImpuestoAsignacionInfo[];
    svcImpCollection: TrackableCollection;
    servicioImpuestosDialog: ImpuestosAsignacionEditor;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, servicioService: ServicioService);
    ngOnInit(): void;
    onConfigureCatalog(options: CatalogOptions): void;
    ngAfterViewChecked(): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    onSelectTab(args: any): void;
    onToolbarButtonClick(button: ToolbarButton): void;
    onAgregarImpuesto(args: ImpuestoAsignacionInfo): void;
    onRemoveItem(item: any): void;
    onAgregarProveedor(): void;
}
