"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var servicio_service_1 = require("../services/servicio.service");
var servicio_1 = require("../models/servicio");
var impuesto_asignacion_editor_1 = require("../../accounting/components/impuesto-asignacion.editor");
var ServiciosEditor = /** @class */ (function (_super) {
    __extends(ServiciosEditor, _super);
    //
    function ServiciosEditor(router, route, formBuilder, changeDetector, context, location, servicioService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.servicioService = servicioService;
        _this.servicio = new servicio_1.ServicioInfo();
        _this.proceso = 0;
        _this.servicioImpuestos = [];
        _this.svcImpCollection = new editors_1.TrackableCollection();
        _this.catalogForm = formBuilder.group({
            //general
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'idCuenta': ['']
        });
        return _this;
    }
    ServiciosEditor_1 = ServiciosEditor;
    ServiciosEditor.prototype.ngOnInit = function () {
        var _this = this;
        this.route.params.forEach(function (param) {
            _this.proceso = +param['proceso'];
        });
    };
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    ServiciosEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
    };
    ServiciosEditor.prototype.ngAfterViewChecked = function () {
        this.svcImpCollection.sourceCollection = this.servicio.impuestos;
    };
    ServiciosEditor.prototype.onCreatingItem = function () {
    };
    ServiciosEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.servicioService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.servicio = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ServiciosEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.servicioService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.servicio = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ServiciosEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.servicioService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.servicio = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ServiciosEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.servicioService.update(this.servicio)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.servicio.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.servicio = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ServiciosEditor.prototype.onSelectTab = function (args) {
        if (args.heading) {
            wijmo_1.Control.invalidateAll();
        }
    };
    /*------------------------------------------ IMPUESTOS ----------------------------------*/
    ServiciosEditor.prototype.onToolbarButtonClick = function (button) {
        if (button.name == 'ADD') {
            this.servicioImpuestosDialog.show();
        }
    };
    ServiciosEditor.prototype.onAgregarImpuesto = function (args) {
        var _this = this;
        var impuestoExists = false;
        this.servicio.impuestos.forEach(function (servicioImp) {
            if (servicioImp.idImpuesto == args.idImpuesto && servicioImp.state != 'DELETED') {
                _this.showAlert("El impuesto ya fue agregado", "información");
                impuestoExists = true;
            }
        });
        if (!impuestoExists) {
            this.servicio.impuestos.push(args);
            this.svcImpCollection.refresh();
        }
    };
    ServiciosEditor.prototype.onRemoveItem = function (item) {
        this.servicio.impuestos.forEach(function (x) {
            if (x.idImpuesto == item.idImpuesto)
                x.state = 'DELETED';
        });
        this.svcImpCollection.remove(item);
        this.svcImpCollection.refresh();
    };
    /*------------------------------------------ PROVEEDORES ----------------------------------*/
    ServiciosEditor.prototype.onAgregarProveedor = function () {
        this.router.navigate(['purchasing/proveedor-servicio', this.proceso, 0, 0, this.servicio.identity, 0, 1, 0, 1]);
    };
    var ServiciosEditor_1;
    __decorate([
        core_1.ViewChild(impuesto_asignacion_editor_1.ImpuestosAsignacionEditor),
        __metadata("design:type", impuesto_asignacion_editor_1.ImpuestosAsignacionEditor)
    ], ServiciosEditor.prototype, "servicioImpuestosDialog", void 0);
    ServiciosEditor = ServiciosEditor_1 = __decorate([
        core_1.Component({
            selector: 'azteca.business.compras-servicio-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor\n                                 [title]=\"'Servicio'\"\n                                 [info]=\"servicio\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"servicio.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"servicio.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"General\" (select)=\"onSelectTab($event)\">\n                              <div class=\"row\">\n                                  <div class=\"col-12\">\n\n                                      <azteca-form-field [label]=\"'Cuenta:'\">\n                                          <accounting-cuenta-selector formControlName=\"idCuenta\" [(ngModel)]=\"servicio.idCuenta\"></accounting-cuenta-selector>\n                                      </azteca-form-field>\n\n                                  </div>\n                              </div>\n\n                          </tab>\n\n                          <tab heading=\"Proveedores\" (select)=\"onSelectTab($event)\">\n                              <button type=\"button\" class=\"btn btn-primary\" (click)=\"onAgregarProveedor()\" [disabled]=\"servicio.identity == 0\">\n                                  <span aria-hidden=\"true\" class=\"glyphicon glyphicon-plus\"></span>\n                                  Agregar \n                              </button>\n                              <purchasing-producto-proveedor  [idServicio]=\"servicio.identity\"\n                                                              [showTitle]=\"false\"\n                                                              [searchElement]=\"false\"\n                                                              [searchByArticulo]=\"false\"\n                                                              [searchByServicio]=\"true\">\n                              </purchasing-producto-proveedor>\n                        \n                        \n\n\n                          </tab>\n\n                          <tab heading=\"Impuestos\" (select)=\"onSelectTab($event)\">\n                              <!--Toolbar Principal-->\n                              <az-toolbar (buttonClick)=\"onToolbarButtonClick($event)\">\n                                  <az-toolbar-button [name]=\"'ADD'\" [type]=\"'primary'\" [text]=\"'Agregar Impuesto'\" [icon]=\"'glyphicon glyphicon-plus'\"></az-toolbar-button>\n                              </az-toolbar>\n\n                              <wj-flex-grid #gridServicioImpuestos style=\"height:550px\"\n                                            [itemsSource]=\"svcImpCollection\">\n\n                                  <wj-flex-grid-column [width]=\"55\" [isReadOnly]=\"true\">\n                                      <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                          <button type=\"button\" class=\"btn btn-default\" (click)=\"onRemoveItem(cell.item)\">\n                                              <span class=\"glyphicon glyphicon-trash\"></span>\n                                          </button>\n                                      </ng-template>\n                                  </wj-flex-grid-column>\n\n                                  <wj-flex-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'impuesto.code'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Impuesto'\" [binding]=\"'impuesto.nombre'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Tasa \u00F3 cuota'\" [binding]=\"'tasaOCuota'\" [width]=\"'30*'\" [isReadOnly]=\"true\" format=\"n2\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Orden calculo'\" [binding]=\"'ordenCalculo'\" [width]=\"'25*'\" [isReadOnly]=\"true\" format=\"n0\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Tipo calculo'\" [binding]=\"'tipoCalculo'\" [width]=\"'25*'\" [isReadOnly]=\"true\" format=\"n0\"></wj-flex-grid-column>\n                              </wj-flex-grid>\n                          </tab>\n\n                   \n                      </tabset>\n                  </div>\n              </div>\n\n          </azteca-catalog-editor>\n\n          <accounting-impuesto-asignacion (dataUpdater)=\"onAgregarImpuesto($event)\">\n\n          </accounting-impuesto-asignacion>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ServiciosEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: servicio_service_1.ServicioService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, servicio_service_1.ServicioService])
    ], ServiciosEditor);
    return ServiciosEditor;
}(editors_1.CatalogEditor));
exports.ServiciosEditor = ServiciosEditor;
