import { ChangeDetectorRef } from '@angular/core';
import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context } from 'framework3/core';
import { CatalogOptions } from 'framework3/custom';
import { CatalogEditor, EditorEventArgs } from 'framework3/editors';
import { SearchRequest, CatalogListComponent } from 'framework3/search';
import { ZonaCompraService } from '../services/zona-compra.service';
import { ZonaCompraInfo } from '../models/zona-compra';
import { ProveedorService } from '../services/proveedor.service';
export declare class ZonasCompraEditor extends CatalogEditor {
    protected router: Router;
    protected route: ActivatedRoute;
    private formBuilder;
    protected changeDetector: ChangeDetectorRef;
    protected context: Context;
    private location;
    private zonaCompraService;
    private proveedorSvc;
    zonaCompra: ZonaCompraInfo;
    requestProveedorArticulo: SearchRequest;
    proveedoresArticulos: any[];
    pageSizeProveedorArticulo: number;
    serverSideProveedorArticulo: boolean;
    totalRowsProveedorArticulo: number;
    pageIndexProveedorArticulo: number;
    catalogList: CatalogListComponent;
    constructor(router: Router, route: ActivatedRoute, formBuilder: FormBuilder, changeDetector: ChangeDetectorRef, context: Context, location: Location, zonaCompraService: ZonaCompraService, proveedorSvc: ProveedorService);
    onConfigureCatalog(options: CatalogOptions): void;
    onCreatingItem(): void;
    onViewingItem(id: number): void;
    onCloningItem(id: number): void;
    onLoadingItem(id: number): void;
    onSavingItem(args: EditorEventArgs): void;
    searchArticuloRequested(request: SearchRequest): void;
    refreshListProveedorArticulios(): void;
    refreshControls(): void;
}
