"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
var wijmo = require("wijmo/wijmo");
var wjcCore = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
var search_1 = require("framework3/search");
//Features
var zona_compra_service_1 = require("../services/zona-compra.service");
var zona_compra_1 = require("../models/zona-compra");
var proveedor_service_1 = require("../services/proveedor.service");
var ZonasCompraEditor = /** @class */ (function (_super) {
    __extends(ZonasCompraEditor, _super);
    function ZonasCompraEditor(router, route, formBuilder, changeDetector, context, location, zonaCompraService, proveedorSvc) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.zonaCompraService = zonaCompraService;
        _this.proveedorSvc = proveedorSvc;
        _this.zonaCompra = new zona_compra_1.ZonaCompraInfo();
        _this.proveedoresArticulos = [];
        _this.pageSizeProveedorArticulo = 20;
        _this.serverSideProveedorArticulo = false;
        _this.totalRowsProveedorArticulo = 0;
        _this.pageIndexProveedorArticulo = 0;
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'idCuenta': ['']
        });
        return _this;
    }
    ZonasCompraEditor_1 = ZonasCompraEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    ZonasCompraEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
        this.applyPolicies();
    };
    ZonasCompraEditor.prototype.onCreatingItem = function () {
    };
    ZonasCompraEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.zonaCompraService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.zonaCompra = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ZonasCompraEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.zonaCompraService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.zonaCompra = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ZonasCompraEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.zonaCompraService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.zonaCompra = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    ZonasCompraEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.zonaCompraService.update(this.zonaCompra)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.reset();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            if (!args.closeEditor && _this.zonaCompra.identity == 0) {
                _this.router.navigate(['../', info.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.zonaCompra = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    /////////////// Articulos ///////////////
    ZonasCompraEditor.prototype.searchArticuloRequested = function (request) {
        this.requestProveedorArticulo = request;
        this.refreshListProveedorArticulios();
    };
    ZonasCompraEditor.prototype.refreshListProveedorArticulios = function () {
        if (this.zonaCompra.identity > 0) {
            this.context.app.showSpinner();
            if (this.requestProveedorArticulo == null) {
                this.requestProveedorArticulo = new search_1.SearchRequest();
                this.requestProveedorArticulo.pageIndex = this.pageIndexProveedorArticulo;
                this.requestProveedorArticulo.pageSize = this.pageSizeProveedorArticulo;
                this.requestProveedorArticulo.paged = this.serverSideProveedorArticulo;
            }
            //this.proveedorSvc.searchProveedorArticuloByZona(this.zonaCompra.identity, this.context.app.defaultSite.identity, this.requestProveedorArticulo)
            //    .then(response => {
            //        this.proveedoresArticulos = response.rows;
            //        this.totalRowsProveedorArticulo = response.totalRows;
            //        this.context.app.hideSpinner();
            //    })
            //    .catch(error => this.handleError(error));
        }
    };
    ZonasCompraEditor.prototype.refreshControls = function () {
        wijmo.Control.invalidateAll();
        if (this.catalogList != null && this.catalogList.grid != null && this.catalogList.grid.collectionView.groupDescriptions.length == 0) {
            this.catalogList.grid.showGroups = true;
            var groupDescApoyo = new wjcCore.PropertyGroupDescription("proveedor");
            this.catalogList.grid.collectionView.groupDescriptions.push(groupDescApoyo);
        }
        this.refreshListProveedorArticulios();
    };
    var ZonasCompraEditor_1;
    __decorate([
        core_1.ViewChild(search_1.CatalogListComponent),
        __metadata("design:type", search_1.CatalogListComponent)
    ], ZonasCompraEditor.prototype, "catalogList", void 0);
    ZonasCompraEditor = ZonasCompraEditor_1 = __decorate([
        core_1.Component({
            selector: 'compras-zona-compra-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor \n                                 [title]=\"'ZonaCompra'\"\n                                 [info]=\"zonaCompra\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"zonaCompra.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"zonaCompra.nombre\"></az-textbox>\n                      </azteca-form-field>\n\n                  </div>\n              </div>\n\n        \n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Gneral\">\n\n                              <div class=\"row\">\n\n                                  <div class=\"col-12\">\n                                      <azteca-form-field [label]=\"'Cuenta:'\">\n                                          <accounting-cuenta-selector formControlName=\"idCuenta\" [(ngModel)]=\"zonaCompra.idCuenta\"></accounting-cuenta-selector>\n                                      </azteca-form-field>\n                                  </div>\n\n                              </div>\n\n                          </tab>\n                          <tab heading=\"Proveedores\" (select)=\"refreshControls()\">\n\n                              <azteca-catalog-list [catalogList]=\"proveedoresArticulos\"\n                                                   [showRowButton]=\"false\"\n                                                   (currentItemChanged)=\"onCurrentItemArticuloChanged($event)\"\n                                                   (searchRequested)=\"searchArticuloRequested($event)\"\n                                                   (contextMenuClick)=\"optionArticuloClick($event)\"\n                                                   [enabled]=\"true\"\n                                                   [pageSize]=\"pageSizeProveedorArticulo\"\n                                                   [serverSide]=\"serverSideProveedorArticulo\"\n                                                   [totalRows]=\"totalRowsProveedorArticulo\"\n                                                   [pageIndex]=\"pageIndexProveedorArticulo\">\n\n                                  <!-- Mapear opciones de men\u00FA de componente padre-->\n                                  <!--\n                                      <azteca-menu-item *ngFor=\"let item of menuItemsArticulo\" [name]=\"item.name\" [icon]=\"item.icon\" [text]=\"item.text\" [smallText]=\"item.smallText\" [enabled]=\"item.enabled\"></azteca-menu-item>\n                                  -->\n                                  <azteca-grid-column [header]=\"'C&oacute;digo'\" [binding]=\"'codigoProveedor'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Proveedor'\" [binding]=\"'proveedor'\" [width]=\"'140*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Art&iacute;culo'\" [binding]=\"'codigoArticulo'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Art&iacute;culo Nombre'\" [binding]=\"'articulo'\" [width]=\"'140*'\" [isReadOnly]=\"true\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Costo'\" [binding]=\"'costo'\" [width]=\"'40*'\" [format]=\"'n0'\"></azteca-grid-column>\n                              </azteca-catalog-list>\n\n                          </tab>\n                          <tab heading=\"Accesos\">\n\n                          </tab>\n                      </tabset>\n                  </div>\n              </div>\n            \n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ZonasCompraEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: zona_compra_service_1.ZonaCompraService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, zona_compra_service_1.ZonaCompraService, proveedor_service_1.ProveedorService])
    ], ZonasCompraEditor);
    return ZonasCompraEditor;
}(editors_1.CatalogEditor));
exports.ZonasCompraEditor = ZonasCompraEditor;
