import { ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { FormBuilder, FormGroup } from '@angular/forms';
import { ModalDirective } from 'ngx-bootstrap';
import { Context, PolicyInfo } from 'framework3/core';
import { BaseControl, AlertsBarComponent } from 'framework3/controls';
import * as wjcCore from 'wijmo/wijmo';
import { DataMap } from 'wijmo/wijmo.grid';
import { ImpuestoService } from '../../accounting/services/impuesto.service';
import { ImpuestoInfo } from '../../accounting/models/impuesto';
import { ArticuloImpuesto } from '../models/articulo';
import { ArticuloService } from '../services/articulo.service';
export declare class ArticuloImpuestoComponent extends BaseControl {
    private context;
    private formBuilder;
    private route;
    private location;
    private articuloSvc;
    private impuestoSvc;
    form: FormGroup;
    dataArticuloImpuesto: wjcCore.CollectionView;
    articuloImpuesto: ArticuloImpuesto;
    articulosImpuestos: Array<ArticuloImpuesto>;
    tiposCalculo: {
        "tipo": string;
        "nombre": string;
    }[];
    tipoCalculoMap: DataMap;
    confirmacionText: string;
    onAceptarConfimracion: any;
    private _IdArticulo;
    idArticulo: number;
    dlgArticuloImpuesto: ModalDirective;
    dlgConfirmacion: ModalDirective;
    alerts: AlertsBarComponent;
    constructor(context: Context, formBuilder: FormBuilder, route: ActivatedRoute, location: Location, articuloSvc: ArticuloService, impuestoSvc: ImpuestoService);
    ngAfterViewInit(): void;
    loadInitialData(): void;
    applyPolicy(policy: PolicyInfo): void;
    handleError(error: any): void;
    onAgregar(): void;
    onSelectedImpuesto(info: ImpuestoInfo): void;
    onCancelarAceptarArticuloImpuesto(): void;
    onAceptarArticuloImpuesto(): void;
    onRowDeleteImpuesto(articuloImpuesto: ArticuloImpuesto): void;
    onCancelarConfirmacion(): void;
    updateArticuloImpuesto(articuloImpuesto: ArticuloImpuesto): void;
    getItems(): Array<ArticuloImpuesto>;
}
