"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
var forms_1 = require("@angular/forms");
var ngx_bootstrap_1 = require("ngx-bootstrap");
//
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var wijmo_grid_1 = require("wijmo/wijmo.grid");
// Features
var impuesto_service_1 = require("../../accounting/services/impuesto.service");
var articulo_1 = require("../models/articulo");
var articulo_service_1 = require("../services/articulo.service");
var ArticuloImpuestoComponent = /** @class */ (function (_super) {
    __extends(ArticuloImpuestoComponent, _super);
    function ArticuloImpuestoComponent(context, formBuilder, route, location, articuloSvc, impuestoSvc) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this.formBuilder = formBuilder;
        _this.route = route;
        _this.location = location;
        _this.articuloSvc = articuloSvc;
        _this.impuestoSvc = impuestoSvc;
        _this.articuloImpuesto = new articulo_1.ArticuloImpuesto();
        _this.articulosImpuestos = new Array();
        _this.tiposCalculo = [{ "tipo": "B", "nombre": "Base" }, { "tipo": "C", "nombre": "Cascada" }];
        _this.confirmacionText = "";
        _this._IdArticulo = 0;
        _this.form = formBuilder.group({
            'idImpuesto': [''],
            'ordenCalculo': [''],
            'tipoCalculo': ['']
        });
        return _this;
    }
    ArticuloImpuestoComponent_1 = ArticuloImpuestoComponent;
    Object.defineProperty(ArticuloImpuestoComponent.prototype, "idArticulo", {
        set: function (idArticulo) {
            this._IdArticulo = idArticulo;
            console.log("Articulo: " + idArticulo);
            //this.loadArticuloImpuestos();
        },
        enumerable: true,
        configurable: true
    });
    ArticuloImpuestoComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) { return _this.loadInitialData(); });
    };
    ArticuloImpuestoComponent.prototype.loadInitialData = function () {
        this.articuloImpuesto = new articulo_1.ArticuloImpuesto();
        this.articuloImpuesto.idArticulo = this._IdArticulo;
        this.tipoCalculoMap = new wijmo_grid_1.DataMap(this.tiposCalculo, 'tipo', 'nombre');
        //this.loadArticuloImpuestos();
    };
    //loadArticuloImpuestos() {
    //    this.articuloSvc.getArticuloImpuestos(this._IdArticulo).then(info => {
    //        this.dataArticuloImpuesto = new wjcCore.CollectionView(info);
    //    })
    //    .catch(error => this.handleError(error));
    //}
    ArticuloImpuestoComponent.prototype.applyPolicy = function (policy) {
    };
    ArticuloImpuestoComponent.prototype.handleError = function (error) {
        this.context.app.hideSpinner();
        var message = this.getErrorMessage(error);
        this.alerts.showAlert(message, 'danger');
    };
    ArticuloImpuestoComponent.prototype.onAgregar = function () {
        this.articuloImpuesto = new articulo_1.ArticuloImpuesto();
        this.articuloImpuesto.idArticulo = this._IdArticulo;
        this.dlgArticuloImpuesto.config.backdrop = false;
        this.dlgArticuloImpuesto.show();
    };
    ArticuloImpuestoComponent.prototype.onSelectedImpuesto = function (info) {
        this.articuloImpuesto.impuesto = info;
    };
    ArticuloImpuestoComponent.prototype.onCancelarAceptarArticuloImpuesto = function () {
        this.dlgArticuloImpuesto.hide();
    };
    ArticuloImpuestoComponent.prototype.onAceptarArticuloImpuesto = function () {
        //// Si existe, preguntar is desea actualizar los datos
        //if (this._IdArticulo > 0) {
        //    var element: ArticuloImpuesto = null;
        //    this.context.app.showSpinner();
        //    this.articuloSvc.existsArticuloImpuesto(this.articuloImpuesto.idArticulo, this.articuloImpuesto.idImpuesto).then(result => {
        //        this.context.app.hideSpinner();
        //        if (result) {
        //            this.dataArticuloImpuesto.items.forEach(function (item) {
        //                if (item.idArticulo == this.articuloImpuesto.idArticulo && item.idImpuesto == this.articuloImpuesto.idImpuesto) {
        //                    element = item;
        //                }
        //            });
        //            //
        //            if (element != null) {
        //                this.confirmacionText = "El impuesto " + this.articuloImpuesto.impuesto.nombre + " ya existe ¿Dese actualizar los datos del impuesto?";
        //                this.onAceptarConfimracion = () => {
        //                    element.ordenCalculo = this.articuloImpuesto.ordenCalculo;
        //                    element.tipoCalculo = this.articuloImpuesto.tipoCalculo;
        //                    this.updateArticuloImpuesto(element);
        //                    this.dlgConfirmacion.hide();
        //                };
        //                this.dlgConfirmacion.config.backdrop = false;
        //                this.dlgConfirmacion.show();
        //            }
        //        }
        //        else {
        //            this.updateArticuloImpuesto(this.articuloImpuesto);
        //        }
        //    }).catch(error => this.handleError(error));
        //}
        //else {
        //    var element: ArticuloImpuesto = null;
        //    var self = this;
        //    this.dataArticuloImpuesto.items.forEach(function (item) {
        //        if (item.idArticulo == self.articuloImpuesto.idArticulo && item.idImpuesto == self.articuloImpuesto.idImpuesto) {
        //            element = item;
        //        }
        //    });
        //    //
        //    if (element != null) {
        //        this.confirmacionText = "El impuesto " + this.articuloImpuesto.impuesto.nombre + " ya existe ¿Dese actualizar los datos del impuesto?";
        //        this.onAceptarConfimracion = () => {
        //            this.dataArticuloImpuesto.editItem(element);
        //            element.ordenCalculo = this.articuloImpuesto.ordenCalculo;
        //            element.tipoCalculo = this.articuloImpuesto.tipoCalculo;
        //            this.dataArticuloImpuesto.commitEdit();
        //            this.dlgConfirmacion.hide();
        //            this.dlgArticuloImpuesto.hide();
        //        };
        //        this.dlgConfirmacion.config.backdrop = false;
        //        this.dlgConfirmacion.show();
        //    }
        //    else {
        //        this.dataArticuloImpuesto.beginUpdate();
        //        this.dataArticuloImpuesto.addNew();
        //        this.dataArticuloImpuesto.currentItem.idArticuloImpuesto = this.articuloImpuesto.idArticuloImpuesto;
        //        this.dataArticuloImpuesto.currentItem.idArticulo = this._IdArticulo;
        //        this.dataArticuloImpuesto.currentItem.idImpuesto = this.articuloImpuesto.idImpuesto;
        //        this.dataArticuloImpuesto.currentItem.ordenCalculo = this.articuloImpuesto.ordenCalculo;
        //        this.dataArticuloImpuesto.currentItem.tipoCalculo = this.articuloImpuesto.tipoCalculo;
        //        this.dataArticuloImpuesto.currentItem.impuesto = this.articuloImpuesto.impuesto;
        //        this.dataArticuloImpuesto.commitNew();
        //        this.dlgArticuloImpuesto.hide();
        //    }
        //}
    };
    ArticuloImpuestoComponent.prototype.onRowDeleteImpuesto = function (articuloImpuesto) {
        //this.confirmacionText = "¿Desea remover el impuesto " + this.dataArticuloImpuesto.currentItem.impuesto.nombre;
        //this.onAceptarConfimracion = () => {
        //    this.context.app.showSpinner();
        //    if (articuloImpuesto.idArticuloImpuesto > 0) {
        //        this.articuloSvc.deleteArticuloImpuesto(articuloImpuesto.idArticuloImpuesto)
        //            .then(result => {
        //                if (result)
        //                    this.dataArticuloImpuesto.remove(this.dataArticuloImpuesto.currentItem);
        //                this.context.app.hideSpinner();
        //            })
        //            .catch(error => this.handleError(error));
        //    }
        //    else {
        //        this.dataArticuloImpuesto.remove(this.dataArticuloImpuesto.currentItem);
        //        this.context.app.hideSpinner();
        //    }
        //    this.dlgConfirmacion.hide();
        //};
        //this.dlgConfirmacion.config.backdrop = false;
        //this.dlgConfirmacion.show();
    };
    ArticuloImpuestoComponent.prototype.onCancelarConfirmacion = function () {
        this.dlgConfirmacion.hide();
    };
    ArticuloImpuestoComponent.prototype.updateArticuloImpuesto = function (articuloImpuesto) {
        //this.context.app.showSpinner();
        //this.articuloSvc.updateArticuloImpuesto(articuloImpuesto).then(result => {
        //    this.loadArticuloImpuestos();
        //    this.dlgArticuloImpuesto.hide();
        //    this.context.app.hideSpinner();
        //}).catch(error => this.handleError(error));
    };
    ArticuloImpuestoComponent.prototype.getItems = function () {
        return this.dataArticuloImpuesto.items;
    };
    var ArticuloImpuestoComponent_1;
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number),
        __metadata("design:paramtypes", [Number])
    ], ArticuloImpuestoComponent.prototype, "idArticulo", null);
    __decorate([
        core_1.ViewChild('dlgArticuloImpuesto'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], ArticuloImpuestoComponent.prototype, "dlgArticuloImpuesto", void 0);
    __decorate([
        core_1.ViewChild('dlgConfirmacion'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], ArticuloImpuestoComponent.prototype, "dlgConfirmacion", void 0);
    __decorate([
        core_1.ViewChild(controls_1.AlertsBarComponent),
        __metadata("design:type", controls_1.AlertsBarComponent)
    ], ArticuloImpuestoComponent.prototype, "alerts", void 0);
    ArticuloImpuestoComponent = ArticuloImpuestoComponent_1 = __decorate([
        core_1.Component({
            selector: 'purchasing-articulo-impuesto',
            template: "\n      <div class=\"row\">\n          <div class=\"col-12 col-lg-12\">\n              <az-panel header=\"Art&iacute;culo Impuestos\">\n                  <button type=\"button\" class=\"btn btn-primary\" (click)=\"onAgregar()\">\n                      <span aria-hidden=\"true\" class=\"glyphicon glyphicon-plus\"></span>\n                      Agregar\n                  </button>\n\n                  <div class=\"row\">\n                      <div class=\"col-12\">\n                          <wj-flex-grid [itemsSource]=\"dataArticuloImpuesto\">\n                              <wj-flex-grid-filter #filter></wj-flex-grid-filter>\n                              <wj-flex-grid-column [header]=\"''\" [width]=\"55\" [isReadOnly]=\"true\">\n                                  <ng-template wjFlexGridCellTemplate [cellType]=\"'Cell'\" let-cell=\"cell\">\n                                      <button type=\"button\" class=\"btn btn-default\" (click)=\"onRowDeleteImpuesto(cell.item)\">\n                                          <span class=\"glyphicon glyphicon-remove\"></span>\n                                      </button>\n                                  </ng-template>\n                              </wj-flex-grid-column>\n                              <wj-flex-grid-column [header]=\"'Impuesto'\" [binding]=\"'impuesto.nombre'\" [width]=\"'*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                              <wj-flex-grid-column [header]=\"'Orden C&aacute;lculo'\" [binding]=\"'ordenCalculo'\" [format]=\"'n0'\"></wj-flex-grid-column>\n                              <wj-flex-grid-column [header]=\"'Tipo C&aacute;lculo'\" [binding]=\"'tipoCalculo'\" [dataMap]=\"tipoCalculoMap\"></wj-flex-grid-column>\n                          </wj-flex-grid>\n                      </div>\n                  </div>\n\n              </az-panel>\n          </div>\n      </div>  \n\n      <!--DIALOGO DE IMPUESTO-->\n      <div bsModal #dlgArticuloImpuesto=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\">\n          <div class=\"modal-dialog\">\n              <div class=\"modal-content\">\n\n                  <div class=\"modal-header\">\n                      <h5 class=\"modal-title\" id=\"exampleModalLabel\">Art&iacute;culo - Impuesto</h5>\n                      <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\" (click)=\"onCancelarAceptarArticuloImpuesto()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n\n                  <div class=\"modal-body\">\n                      <alerts-bar></alerts-bar>\n                      <form [formGroup]=\"form\">\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <azteca-form-field [label]=\"'Impuesto:'\">\n                                      <accounting-impuestos-selector formControlName=\"idImpuesto\"\n                                                                     [(ngModel)]=\"articuloImpuesto.idImpuesto\"\n                                                                     [traslado]=\"true\"\n                                                                     [retencion]=\"true\"\n                                                                     [showListButton]=\"true\"\n                                                                     (selectedItemChanged)=\"onSelectedImpuesto($event)\">\n                                      </accounting-impuestos-selector>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <azteca-form-field [label]=\"'Orden de C&aacute;lculo:'\">\n                                      <az-input-number formControlName=\"ordenCalculo\" [(ngModel)]=\"articuloImpuesto.ordenCalculo\"></az-input-number>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <azteca-form-field [label]=\"'Tipo de C&aacute;lculo:'\">\n                                      <az-combobox formControlName=\"tipoCalculo\"\n                                                   [(ngModel)]=\"articuloImpuesto.tipoCalculo\"\n                                                   [items]=\"tiposCalculo\"\n                                                   [valueMember]=\"'tipo'\"\n                                                   [displayMember]=\"'nombre'\">\n                                      </az-combobox>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                      </form>\n\n                  </div>\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn\" (click)=\"onCancelarAceptarArticuloImpuesto()\">Cancelar</button>\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onAceptarArticuloImpuesto()\">Aceptar</button>\n                  </div>\n              </div>\n          </div>\n      </div>\n\n      <!--DIALOGO DE CONFIRMACION-->\n      <div bsModal #dlgConfirmacion=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\">\n          <div class=\"modal-dialog\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h5 class=\"modal-title\" id=\"exampleModalLabel\">Confirmaci&oacute;n</h5>\n                      <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\" (click)=\"onCancelarConfirmacion()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n                  <div class=\"modal-body\">\n                      <span>{{confirmacionText}}</span>\n                  </div>\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn\" (click)=\"onCancelarConfirmacion()\">\n                          <span aria-hidden=\"true\" class=\"glyphicon glyphicon-remove\"></span>\n                          Cancelar\n                      </button>\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onAceptarConfimracion()\">\n                          <span aria-hidden=\"true\" class=\"glyphicon glyphicon-ok\"></span>\n                          Aceptar\n                      </button>\n                  </div>\n              </div>\n          </div>\n      </div>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return ArticuloImpuestoComponent_1; })
                }
            ],
        }),
        __metadata("design:paramtypes", [core_2.Context, forms_1.FormBuilder, router_1.ActivatedRoute, common_1.Location,
            articulo_service_1.ArticuloService, impuesto_service_1.ImpuestoService])
    ], ArticuloImpuestoComponent);
    return ArticuloImpuestoComponent;
}(controls_1.BaseControl));
exports.ArticuloImpuestoComponent = ArticuloImpuestoComponent;
