import { ActivatedRoute } from '@angular/router';
import { Location } from '@angular/common';
import { FormBuilder, FormGroup } from '@angular/forms';
import { BaseComponent, Context, PolicyInfo } from 'framework3/core';
import { ToolbarButtonDirective, AlertsBarComponent } from 'framework3/controls';
import { ProveedorArticulo } from '../models/proveedor';
import { ArticuloService } from '../services/articulo.service';
import { ArticuloInfo } from '../models/articulo';
import { UnidadMedidaService } from '../../inventory/services/unidad-medida.service';
import { UnidadMedidaItem } from '../../inventory/models/unidad-medida';
import { UnidadMedidaTipoService } from '../../inventory/services/unidad-medida-tipo.service';
import { UnidadMedidaTipoItem } from '../../inventory/models/unidad-medida-tipo';
import { ProveedorService } from '../services/proveedor.service';
export declare class ProveedorArtioculoComponent extends BaseComponent {
    private context;
    private formBuilder;
    private route;
    private location;
    private proveedorSvc;
    private articuloSvc;
    private unidadMedidaService;
    private tipoUnidadService;
    form: FormGroup;
    proveedorArticulo: ProveedorArticulo;
    articulo: ArticuloInfo;
    tiposUnidad: UnidadMedidaTipoItem[];
    unidadesMedida: UnidadMedidaItem[];
    editProveedor: boolean;
    editArticulo: boolean;
    editZona: boolean;
    idProveedorArticulo: number;
    idProveedor: number;
    idArticulo: number;
    idZona: number;
    alerts: AlertsBarComponent;
    constructor(context: Context, formBuilder: FormBuilder, route: ActivatedRoute, location: Location, proveedorSvc: ProveedorService, articuloSvc: ArticuloService, unidadMedidaService: UnidadMedidaService, tipoUnidadService: UnidadMedidaTipoService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    loadInitialData(): void;
    applyPolicy(policy: PolicyInfo): void;
    handleError(error: any): void;
    loadTiposUnidad(): void;
    onTipoUnidadChanged(idTipoUnidad: any): void;
    loadUnidadesMedida(idTipoUnidad: number): void;
    mainToolbarHandler(button: ToolbarButtonDirective): void;
}
