import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo } from 'framework3/core';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { OrdenInfo } from '../models/orden';
import { OrdenDetail } from '../models/orden-detail';
import { OrdenService } from '../services/orden.service';
import { OrdenDetailEditor } from './parts/ordenes-detail.editor';
import { CentralItem } from '../models/central';
import { CentralService } from '../services/central.service';
import { DepartamentoItem } from '../models/departamento';
import { DepartamentoService } from '../services/departamento.service';
import { CentroRecepcionService } from '../services/centro-recepcion.service';
import { ProveedorInfo } from '../models/proveedor';
import { SecurityContext } from '../models/security-context';
import { ImportesInfo } from '../../accounting/models/importes';
import { DivisaInfo } from '../../accounting';
export declare class OrdenesEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private ordenService;
    private centralService;
    private departamentoService;
    private centroRecepcionService;
    orden: OrdenInfo;
    securityContext: SecurityContext[];
    centrales: CentralItem[];
    departamentos: DepartamentoItem[];
    centrosRecepcion: CentralItem[];
    articulos: OrdenDetail[];
    servicios: OrdenDetail[];
    detailsList: EditableListComponent;
    detailsEditor: OrdenDetailEditor;
    articulosList: EditableListComponent;
    serviciosList: EditableListComponent;
    readonly importes: ImportesInfo;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, ordenService: OrdenService, centralService: CentralService, departamentoService: DepartamentoService, centroRecepcionService: CentroRecepcionService);
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    combineDetail(): OrdenDetail[];
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
    onAddingDetail(): void;
    onEditingDetail(detail: OrdenDetail): void;
    onDeletingDetail(detail: OrdenDetail): void;
    onListItemsUpdated(updatedDetails: OrdenDetail[]): void;
    onSavingDetail(detail: OrdenDetail): void;
    loadCentrales(): void;
    loadCentrosRecepcion(idCentral: number): void;
    loadDepartamentos(idCentroRecepcion: number): void;
    onProveedorChanged(proveedor: ProveedorInfo): void;
    onDivisaChanged(divisa: DivisaInfo): void;
    onAddingArticulo(): void;
    onEditingArticulo(detail: OrdenDetail): void;
    onDeletingArticulo(detail: OrdenDetail): void;
    onArticulosUpdated(updatedItems: OrdenDetail[]): void;
    onSavingArticulo(detail: OrdenDetail): void;
    onSavingArticulos(details: OrdenDetail[]): void;
    onAddingServicio(): void;
    onEditingServicio(detail: OrdenDetail): void;
    onDeletingServicio(detail: OrdenDetail): void;
    onServiciosUpdated(updatedServices: OrdenDetail[]): void;
    onSavingServicio(detail: OrdenDetail): void;
    onSavingServicios(details: OrdenDetail[]): void;
    importesDesglosados(): ImportesInfo;
}
