import { FormBuilder } from '@angular/forms';
import { CollectionView } from 'wijmo/wijmo';
import { FlexGrid, CellRangeEventArgs, FormatItemEventArgs } from 'wijmo/wijmo.grid';
import { Context } from 'framework3/core';
import { BasicEditor } from 'framework3/editors';
import { UnidadMedidaItem, UnidadMedidaService } from '../../../inventory';
import { OrdenDetail } from '../../models/orden-detail';
import { DepartamentoItem } from '../../models/departamento';
import { PresupuestoService } from '../../services/presupuesto.service';
import { PresupuestoItem } from '../../models/presupuesto';
import { ArticuloInfo } from '../../models/articulo';
import { ArticuloService } from '../../services/articulo.service';
import { ServicioInfo } from '../../models/servicio';
import { ServicioService } from '../../services/servicio.service';
export declare class OrdenDetailEditor extends BasicEditor {
    protected context: Context;
    private builder;
    private unidadMedidaService;
    private presupuestoService;
    private articuloService;
    private servicioService;
    detailCopy: OrdenDetail;
    trasladosCollection: CollectionView;
    retencionesCollection: CollectionView;
    detail: OrdenDetail;
    departamentos: DepartamentoItem[];
    idProveedor: number;
    costoUnitario: string;
    departamento: DepartamentoItem;
    presupuestos: PresupuestoItem[];
    presupuesto: PresupuestoItem;
    unidadesMedida: UnidadMedidaItem[];
    constructor(context: Context, builder: FormBuilder, unidadMedidaService: UnidadMedidaService, presupuestoService: PresupuestoService, articuloService: ArticuloService, servicioService: ServicioService);
    onCreatingItem(): void;
    onLoadingItem(detail: OrdenDetail): void;
    onUpdatingItem(detail: OrdenDetail): void;
    onDepartamentoChanged(idDepartamento: number): void;
    onServicioChanged(servicio: ServicioInfo): void;
    onArticuloChanged(articulo: ArticuloInfo): void;
    loadUnidadesMedida(idTipoUnidad: number): void;
    validators(): void;
    onEditCell(grid: FlexGrid, args: CellRangeEventArgs): void;
    onFormatCell(grid: FlexGrid, args: FormatItemEventArgs): void;
}
