"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
var wijmo_grid_1 = require("wijmo/wijmo.grid");
//Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Inventario
var inventory_1 = require("../../../inventory");
var accounting_1 = require("../../../accounting");
//Locales
var orden_detail_1 = require("../../models/orden-detail");
var departamento_1 = require("../../models/departamento");
var presupuesto_service_1 = require("../../services/presupuesto.service");
var presupuesto_1 = require("../../models/presupuesto");
var articulo_service_1 = require("../../services/articulo.service");
var servicio_1 = require("../../models/servicio");
var servicio_service_1 = require("../../services/servicio.service");
var controls_1 = require("framework3/controls");
var OrdenDetailEditor = /** @class */ (function (_super) {
    __extends(OrdenDetailEditor, _super);
    function OrdenDetailEditor(context, builder, unidadMedidaService, presupuestoService, articuloService, servicioService) {
        var _this = _super.call(this, context) || this;
        _this.context = context;
        _this.builder = builder;
        _this.unidadMedidaService = unidadMedidaService;
        _this.presupuestoService = presupuestoService;
        _this.articuloService = articuloService;
        _this.servicioService = servicioService;
        //Copia temporal que se utilizará para edición y no afecte al objeto original por si el usuario decide cancelar la edición
        _this.detailCopy = new orden_detail_1.OrdenDetail();
        _this.trasladosCollection = new wijmo_1.CollectionView();
        _this.retencionesCollection = new wijmo_1.CollectionView();
        //Objeto original que se editará
        _this.detail = new orden_detail_1.OrdenDetail();
        _this.departamentos = [];
        _this.idProveedor = 0;
        _this.costoUnitario = '$0.0';
        _this.departamento = new departamento_1.DepartamentoItem();
        _this.presupuestos = [];
        _this.presupuesto = new presupuesto_1.PresupuestoItem();
        _this.unidadesMedida = [];
        _this.form = builder.group({
            'idDepartamento': [0, forms_1.Validators.required],
            'idArticulo': [0],
            'idUnidadMedida': [0],
            'idServicio': [0],
            'cantidad': [0, forms_1.Validators.required],
            'idPresupuesto': [0],
            'idCategoriaPresupuestal': [0],
            'observaciones': [''],
            'costo': [0],
        });
        _this.trasladosCollection.filter = function (item) {
            return item.tipoAplicacion == accounting_1.TipoAplicacion.TRASLADO;
        };
        _this.retencionesCollection.filter = function (item) {
            return item.tipoAplicacion == accounting_1.TipoAplicacion.RETENCION;
        };
        return _this;
    }
    /////////////////// METODOS ///////////////////////////////
    /////////////////// HANDLERS //////////////////////////////
    OrdenDetailEditor.prototype.onCreatingItem = function () {
        this.detailCopy = this.detail;
        this.form.reset({ idArticulo: 0, idServicio: 0, idUnidadMedida: 0, Cantidad: 0, idPresupuesto: 0, idCategoriaPresupuestal: 0, costo: 0 });
        this.form.markAsPristine();
    };
    OrdenDetailEditor.prototype.onLoadingItem = function (detail) {
        this.detailCopy = this.copyItem(this.detail);
        this.validators();
    };
    OrdenDetailEditor.prototype.onUpdatingItem = function (detail) {
        if (this.detailCopy._clientID == 0) {
            this.detailCopy._clientID = this.createClientID();
        }
        else {
            this.detailCopy.state = editors_1.ChangeState.MODIFIED;
        }
        this.savingItem.emit(this.detailCopy);
    };
    OrdenDetailEditor.prototype.onDepartamentoChanged = function (idDepartamento) {
        this.departamento = this.departamentos.find(function (item) { return item.id == idDepartamento; });
    };
    OrdenDetailEditor.prototype.onServicioChanged = function (servicio) {
        var _this = this;
        if (servicio) {
            this.detailCopy.servicio = servicio;
            ////Hacer requerido el campo de descripción cuando el servicio sea de concepto libre
            //if (this.detailCopy.articuloServicio=="S") {
            //    this.form.controls.idServicio.setValidators(Validators.required);
            //}
            //else {
            //    this.form.controls.idServicio.setValidators(null);
            //}
            //this.form.controls.descripcion.updateValueAndValidity();
            //Cargar información de precios del servicio
            this.servicioService.calcularCostoProveedor(this.detailCopy.idServicio, this.idProveedor, this.context.app.defaultCompany.identity, 0)
                .then(function (costo) {
                _this.detailCopy.costoUnitario = costo.costoBase;
                _this.detailCopy.costoNeto = costo.costoNeto;
                _this.detailCopy.impuestos = costo.impuestos;
                _this.detailCopy.descuentos = costo.descuentos;
                //
                _this.trasladosCollection.sourceCollection = costo.impuestos;
                _this.retencionesCollection.sourceCollection = costo.impuestos;
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else {
            this.detailCopy.servicio = new servicio_1.ServicioInfo();
        }
        this.trasladosCollection.sourceCollection = null;
        this.retencionesCollection.sourceCollection = null;
    };
    OrdenDetailEditor.prototype.onArticuloChanged = function (articulo) {
        var _this = this;
        if (articulo) {
            this.detailCopy.articulo = articulo;
            this.loadUnidadesMedida(this.detailCopy.articulo.articuloStock.unidadMedida.idUnidadMedidaTipo);
            this.articuloService.calcularCostoProveedor(this.detailCopy.idArticulo, this.idProveedor, this.context.app.defaultCompany.identity)
                .then(function (costo) {
                _this.detailCopy.costoUnitario = costo.costoBase;
                _this.detailCopy.costoNeto = costo.costoNeto;
                _this.detailCopy.descuentos = costo.descuentos;
                _this.detailCopy.impuestos = costo.impuestos;
                _this.costoUnitario = wijmo_1.Globalize.formatNumber(_this.detailCopy.costoUnitario, 'c');
                //
                _this.trasladosCollection.sourceCollection = costo.impuestos;
                _this.retencionesCollection.sourceCollection = costo.impuestos;
            })
                .catch(function (error) { return _this.handleError(error); });
        }
        else {
            this.detailCopy.servicio = new servicio_1.ServicioInfo();
        }
        this.trasladosCollection.sourceCollection = null;
        this.retencionesCollection.sourceCollection = null;
    };
    OrdenDetailEditor.prototype.loadUnidadesMedida = function (idTipoUnidad) {
        var _this = this;
        //Si el articulo esta controlado por series, no se puede cambiar la unidad de medida, por lo tanto solo se debe utilizar la unidad de medida el articulo,
        //en caso contrario, cargar lista de unidades de medida del mismo tipo
        if (this.detailCopy.articulo.articuloStock.manejaSeries) {
            var unidadArticulo = this.detailCopy.articulo.articuloStock.unidadMedida;
            var newUnidad = {
                id: unidadArticulo.identity, codigo: unidadArticulo.code, idUnidadMedidaTipo: unidadArticulo.idUnidadMedidaTipo, base: unidadArticulo.base,
                factor: unidadArticulo.factor, fraccionable: unidadArticulo.fraccionable, paquete: unidadArticulo.paquete, activo: true
            };
            var newUnidades = [];
            newUnidades.push(newUnidad);
            this.unidadesMedida = newUnidades;
            this.detailCopy.idUnidadMedida = unidadArticulo.identity;
        }
        else {
            this.unidadMedidaService.loadList(idTipoUnidad)
                .then(function (unidadesMedida) {
                _this.unidadesMedida = unidadesMedida;
                _this.detailCopy.idUnidadMedida = _this.detailCopy.articulo.idUnidadMedida;
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    OrdenDetailEditor.prototype.validators = function () {
        if (this.detailCopy.articuloServicio == "A") {
            this.form.controls.idArticulo.setValidators(controls_1.AztecaValidators.selected);
            this.form.controls.idUnidadMedida.setValidators(controls_1.AztecaValidators.selected);
            this.form.controls.idServicio.setValidators(null);
        }
        else {
            this.form.controls.idServicio.setValidators(controls_1.AztecaValidators.selected);
            this.form.controls.idArticulo.setValidators(null);
            this.form.controls.idUnidadMedida.setValidators(null);
        }
        this.form.controls.idArticulo.updateValueAndValidity();
        this.form.controls.idUnidadMedida.updateValueAndValidity();
        this.form.controls.idServicio.updateValueAndValidity();
    };
    OrdenDetailEditor.prototype.onEditCell = function (grid, args) {
        if (!grid.rows[args.row].dataItem.impuesto.rango && grid.columns[args.col].binding == 'tasaOCuota') {
            args.cancel = true;
        }
    };
    OrdenDetailEditor.prototype.onFormatCell = function (grid, args) {
        if (args.panel.cellType == wijmo_grid_1.CellType.Cell && !grid.rows[args.row].dataItem.impuesto.rango && grid.columns[args.col].binding == 'tasaOCuota') {
            args.cell.style.backgroundColor = '#C0C0C0';
        }
    };
    __decorate([
        core_1.Input(),
        __metadata("design:type", orden_detail_1.OrdenDetail)
    ], OrdenDetailEditor.prototype, "detail", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Array)
    ], OrdenDetailEditor.prototype, "departamentos", void 0);
    __decorate([
        core_1.Input(),
        __metadata("design:type", Number)
    ], OrdenDetailEditor.prototype, "idProveedor", void 0);
    OrdenDetailEditor = __decorate([
        core_1.Component({
            selector: 'compras-orden-detail-editor',
            template: "\n      <form [formGroup]=\"form\">\n          <azteca-basic-editor [item]=\"detail\"\n                               [dirty]=\"dirty\"\n                               [valid]=\"valid\"\n                               (creatingItem)=\"onCreatingItem()\"\n                               (loadingItem)=\"onLoadingItem($event)\"\n                               (updatingItem)=\"onUpdatingItem($event)\">\n\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-6\">\n                      <azteca-form-field [label]=\"'Departamento:'\">\n                          <az-combobox formControlName=\"idDepartamento\"\n                                       [(ngModel)]=\"detailCopy.idDepartamento\"\n                                       [items]=\"departamentos\"\n                                       [displayMember]=\"'nombre'\"\n                                       [valueMember]=\"'id'\"\n                                       (selectedItemChanged)=\"onDepartamentoChanged($event)\">\n                          </az-combobox>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-8\">\n                      <azteca-form-field [label]=\"'Articulo:'\" *ngIf=\"detailCopy.articuloServicio=='A'\">\n                          <purchasing-articulo-selector formControlName=\"idArticulo\"\n                                                        [(ngModel)]=\"detailCopy.idArticulo\"\n                                                        (selectedItemChanged)=\"onArticuloChanged($event)\"\n                                                        (articuloUpdated)=\"onArticuloChanged($event)\">\n                          </purchasing-articulo-selector>\n                      </azteca-form-field>\n                  </div>\n\n                  <div class=\"col-12 col-md-4\">\n                      <azteca-form-field [label]=\"'Unidad de medida:'\" *ngIf=\"detailCopy.articuloServicio=='A'\">\n                          <az-combobox formControlName=\"idUnidadMedida\"\n                                       [(ngModel)]=\"detailCopy.idUnidadMedida\"\n                                       [items]=\"unidadesMedida\"\n                                       [displayMember]=\"'nombre'\"\n                                       [valueMember]=\"'id'\">\n                          </az-combobox>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-8\">\n                      <azteca-form-field [label]=\"'Servicio:'\" *ngIf=\"detailCopy.articuloServicio=='S'\">\n                          <purchasing-servicios-selector formControlName=\"idServicio\"\n                                                         (selectedItemChanged)=\"onServicioChanged($event)\"\n                                                         [(ngModel)]=\"detailCopy.idServicio\"\n                                                         (itemSelected)=\"onServicioChanged($event)\">\n                          </purchasing-servicios-selector>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-3\">\n                      <azteca-form-field [label]=\"'Cantidad:'\">\n                          <az-input-number formControlName=\"cantidad\"\n                                           [(ngModel)]=\"detailCopy.cantidad\">\n                          </az-input-number>\n                      </azteca-form-field>\n                  </div>\n\n                  <div class=\"col-12 col-lg-6\">\n                      <azteca-form-field [label]=\"'Costo:'\">\n                          <az-input-number formControlName=\"costo\" [(ngModel)]=\"detailCopy.costoUnitario\" [enabled]=\"false\"></az-input-number>\n                      </azteca-form-field>\n                  </div>\n\n              </div>\n\n              <az-panel [header]=\"'Presupuesto'\" type=\"success\" *ngIf=\"!departamento.tipoPresupuesto=='N'\">\n                  <div class=\"row\">\n                      <div class=\"col-12 col-md-6\">\n                          <azteca-form-field [label]=\"'Presupuesto:'\" *ngIf=\"!departamento.tipoPresupuesto=='N'\">\n                              <az-combobox formControlName=\"idPresupuesto\"\n                                           [(ngModel)]=\"detailCopy.idPresupuesto\"\n                                           [items]=\"presupuestos\"\n                                           [displayMember]=\"'nombre'\"\n                                           [valueMember]=\"'id'\">\n                              </az-combobox>\n                          </azteca-form-field>\n                      </div>\n                      <div class=\"col-12 col-md-6\">\n                          <azteca-form-field [label]=\"'Categoria Presupuestal:'\" *ngIf=\"departamento.tipoPresupuesto=='C'\">\n                              <az-combobox formControlName=\"idCategoriaPresupuestal\"\n                                           [(ngModel)]=\"detailCopy.idCategoriaPresupuestal\"\n                                           [items]=\"presupuesto.details\"\n                                           [displayMember]=\"'categoriaPresupuestal.nombre'\"\n                                           [valueMember]=\"'idCategoriaPresupuestal'\">\n                              </az-combobox>\n                          </azteca-form-field>\n                      </div>\n                  </div>\n              </az-panel>\n\n              <!--GRID DE TRASLADOS-->\n              <div class=\"row\">            \n                  <div class=\"col-12\">\n                      <label class=\"control-label\">Traslados:</label>\n                      <wj-flex-grid #gridTraslados style=\"height:120px\" [itemsSource]=\"trasladosCollection\"\n                                    (beginningEdit)=\"onEditCell(gridTraslados, $event)\" (formatItem)=\"onFormatCell(gridTraslados, $event)\">\n                          <wj-flex-grid-column [header]=\"'Impuesto'\" [binding]=\"'impuesto.nombre'\" [width]=\"'30*'\" [isReadOnly]=\"false\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Factor'\" [binding]=\"'tipoFactor'\" [width]=\"'20*'\" [isReadOnly]=\"false\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Base'\" [binding]=\"'base'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Tasa \u00F3 cuota'\" [binding]=\"'tasaOCuota'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                      </wj-flex-grid>\n                  </div>\n              </div>\n\n              <!--GRID DE RETENCIONES-->\n              <div class=\"row\" *ngIf=\"detailCopy.articuloServicio=='S'\">\n                  <div class=\"col-12\">\n\n                      <label class=\"control-label\">Retenciones:</label>\n                      <wj-flex-grid #gridRetenciones style=\"height:120px\" [itemsSource]=\"retencionesCollection\"\n                                    (beginningEdit)=\"onEditCell(gridRetenciones, $event)\" (formatItem)=\"onFormatCell(gridRetenciones, $event)\">\n                          <wj-flex-grid-column [header]=\"'Impuesto'\" [binding]=\"'impuesto.nombre'\" [width]=\"'30*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Factor'\" [binding]=\"'tipoFactor'\" [width]=\"'20*'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Base'\" [binding]=\"'base'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                          <wj-flex-grid-column [header]=\"'Tasa \u00F3 cuota'\" [binding]=\"'tasaOCuota'\" [width]=\"'20*'\"></wj-flex-grid-column>\n                      </wj-flex-grid>\n\n                  </div>\n              </div>\n\n          </azteca-basic-editor>\n      </form>\n    "
        }),
        __metadata("design:paramtypes", [core_2.Context, forms_1.FormBuilder, inventory_1.UnidadMedidaService,
            presupuesto_service_1.PresupuestoService,
            articulo_service_1.ArticuloService,
            servicio_service_1.ServicioService])
    ], OrdenDetailEditor);
    return OrdenDetailEditor;
}(editors_1.BasicEditor));
exports.OrdenDetailEditor = OrdenDetailEditor;
