import { Router, ActivatedRoute } from '@angular/router';
import { FormGroup, FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { ModalDirective } from 'ngx-bootstrap';
import * as wjcCore from 'wijmo/wijmo';
import { Context, DocumentTypeService, PolicyInfo } from 'framework3/core';
import { BaseControl } from 'framework3/controls';
import { CategoriaPresupuestalListComponent } from '../dialogs/categorias-presupuestal-list.component';
import { PresupuestoInfo } from '../models/presupuesto';
import { PresupuestoService } from '../services/presupuesto.service';
import { PresupuestoPartidaInfo } from '../models/presupuesto-partida';
export declare class PresupuestosEditor extends BaseControl {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private presupuestoService;
    form: FormGroup;
    formPresupuesto: FormGroup;
    dataPartidas: wjcCore.CollectionView;
    dataCategorias: wjcCore.CollectionView;
    presupuesto: PresupuestoInfo;
    partida: PresupuestoPartidaInfo;
    dlgPartida: ModalDirective;
    dlgCategoriaPresupuestal: CategoriaPresupuestalListComponent;
    tiposPartidas: {
        "tipoPartida": string;
        "nombre": string;
    }[];
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, presupuestoService: PresupuestoService);
    ngAfterViewInit(): void;
    loadInitialData(): void;
    applyPolicy(policy: PolicyInfo): void;
    onMontoIgual(): void;
    onAgregarPartida(name: any, fechaIni: any, fechaFin: any): void;
    onSelectedTipoPartida(args: any): void;
    agregarPartida(name: string, fechaIni: Date, fechaFin: Date, monto: number): void;
    onCancelarPartida(): void;
    onAceptarPartida(): void;
    onAgregarCategoria(): void;
}
