"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
var moment = require("moment");
//Bootstrap
var ngx_bootstrap_1 = require("ngx-bootstrap");
//Wijmo
var wjcCore = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var categorias_presupuestal_list_component_1 = require("../dialogs/categorias-presupuestal-list.component");
var presupuesto_1 = require("../models/presupuesto");
var presupuesto_service_1 = require("../services/presupuesto.service");
var presupuesto_partida_1 = require("../models/presupuesto-partida");
var PresupuestosEditor = /** @class */ (function (_super) {
    __extends(PresupuestosEditor, _super);
    function PresupuestosEditor(context, router, route, location, formBuilder, documentTypeService, presupuestoService) {
        var _this = _super.call(this) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.documentTypeService = documentTypeService;
        _this.presupuestoService = presupuestoService;
        _this.presupuesto = new presupuesto_1.PresupuestoInfo();
        _this.partida = new presupuesto_partida_1.PresupuestoPartidaInfo();
        _this.tiposPartidas = [
            { "tipoPartida": "E", "nombre": "Ejercicio" },
            { "tipoPartida": "P", "nombre": "Periodo" },
            { "tipoPartida": "M", "nombre": "Manual" }
        ];
        //
        _this.form = formBuilder.group({
            'nombre': [],
            'montoPresupuesto': [],
            'tiposPartidas': [],
            'fechaIni': [],
            'fechaFin': []
        });
        //
        _this.formPresupuesto = formBuilder.group({
            'nombre': [],
            'montoPresupuesto': [],
            'tiposPartidas': [],
            'fechaIni': [],
            'fechaFin': []
        });
        return _this;
    }
    PresupuestosEditor_1 = PresupuestosEditor;
    PresupuestosEditor.prototype.ngAfterViewInit = function () {
        var _this = this;
        setTimeout(function (_) { return _this.loadInitialData(); });
    };
    PresupuestosEditor.prototype.loadInitialData = function () {
        this.dataPartidas = new wjcCore.CollectionView();
        this.dataCategorias = new wjcCore.CollectionView();
        moment.locale('es');
    };
    PresupuestosEditor.prototype.applyPolicy = function (policy) {
    };
    PresupuestosEditor.prototype.onMontoIgual = function () {
        this.dataPartidas.beginUpdate();
        if (this.dataPartidas.items.length > 0) {
            var self_1 = this;
            var monto_1 = this.presupuesto.montoPresupuesto / this.dataPartidas.items.length;
            this.dataPartidas.items.forEach(function (item) {
                self_1.dataPartidas.editItem(item);
                item.montoPresupuesto = monto_1;
            });
            this.dataPartidas.commitEdit();
        }
    };
    PresupuestosEditor.prototype.onAgregarPartida = function (name, fechaIni, fechaFin) {
        var now = new Date();
        //
        this.partida = new presupuesto_partida_1.PresupuestoPartidaInfo();
        this.partida.nombre = moment(now).format("MMMM").toUpperCase();
        this.partida.fechaIni = new Date(now.getFullYear(), now.getMonth(), 1);
        this.partida.fechaFin = new Date();
        this.partida.montoPresupuesto = 0;
        this.partida.montoUtilizado = 0;
        this.partida.montoDisponible = 0;
        //
        this.dlgPartida.config.backdrop = false;
        this.dlgPartida.show();
    };
    PresupuestosEditor.prototype.onSelectedTipoPartida = function (args) {
        if (args == "E" && this.presupuesto.identity.trim() == "" && this.dataPartidas.items.length == 0) {
            this.presupuesto.fechaIni = new Date(2018, 0, 1);
            this.presupuesto.fechaFin = new Date(2018, 11, 31);
            var monto = this.presupuesto.montoPresupuesto / 12;
            for (var periodo = 0; periodo < 12; periodo++) {
                var ejercicio = new Date(2018, periodo, 1);
                var name_1 = moment(ejercicio).format("MMMM").toUpperCase();
                var fechaFin = new Date(2018, periodo + 1, 0);
                this.agregarPartida(name_1, ejercicio, fechaFin, monto);
            }
        }
    };
    PresupuestosEditor.prototype.agregarPartida = function (name, fechaIni, fechaFin, monto) {
        this.dataPartidas.beginUpdate();
        var partida = this.dataPartidas.addNew();
        partida.fechaAfectacion = new Date();
        partida.nombre = name;
        partida.idPresupuesto = this.presupuesto.identity;
        partida.fechaPresupuesto = this.presupuesto.fechaSys;
        partida.fechaIni = fechaIni;
        partida.fechaFin = fechaFin;
        partida.montoPresupuesto = monto;
        partida.montoUtilizado = 0;
        partida.montoDisponible = 0;
        partida.estatus = "G";
        this.dataPartidas.commitNew();
    };
    PresupuestosEditor.prototype.onCancelarPartida = function () {
        this.dlgPartida.hide();
    };
    PresupuestosEditor.prototype.onAceptarPartida = function () {
        this.agregarPartida(this.partida.nombre, this.partida.fechaIni, this.partida.fechaFin, this.partida.montoPresupuesto);
        this.dlgPartida.hide();
    };
    PresupuestosEditor.prototype.onAgregarCategoria = function () {
        this.dlgCategoriaPresupuestal.show();
    };
    var PresupuestosEditor_1;
    __decorate([
        core_1.ViewChild('dlgPartida'),
        __metadata("design:type", ngx_bootstrap_1.ModalDirective)
    ], PresupuestosEditor.prototype, "dlgPartida", void 0);
    __decorate([
        core_1.ViewChild('dlgCategoriaPresupuestal'),
        __metadata("design:type", categorias_presupuestal_list_component_1.CategoriaPresupuestalListComponent)
    ], PresupuestosEditor.prototype, "dlgCategoriaPresupuestal", void 0);
    PresupuestosEditor = PresupuestosEditor_1 = __decorate([
        core_1.Component({
            selector: 'credito-presupuestos-editor',
            template: "\n      <form [formGroup]=\"form\">\n\n          <div class=\"row\">\n              <div class=\"col-12 col-lg-12\">\n                  <alerts-bar></alerts-bar>\n\n                  <az-panel header=\"Presupuesto\">\n\n                      <az-toolbar>\n                          <az-toolbar-button [name]=\"'SAVE'\" [type]=\"'primary'\" [text]=\"'Guardar Cambios'\" [icon]=\"'glyphicon glyphicon-floppy-disk'\"></az-toolbar-button>\n                          <az-toolbar-button [name]=\"'CLOSE'\" [text]=\"'Cerrar'\" [icon]=\"'glyphicon glyphicon-remove'\"></az-toolbar-button>\n                      </az-toolbar>\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-lg-6\">\n                              <azteca-form-field [label]=\"'Nombre:'\">\n                                  <az-textbox formControlName=\"nombre\"\n                                              [(ngModel)]=\"presupuesto.nombre\"></az-textbox>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-lg-4\">\n                              <azteca-form-field [label]=\"'Presupuesto:'\">\n                                  <az-input-number formControlName=\"montoPresupuesto\"\n                                                   [format]=\"n2\"\n                                                   [(ngModel)]=\"presupuesto.montoPresupuesto\"></az-input-number>\n                              </azteca-form-field>\n                          </div>\n\n                          <div class=\"col-12 col-lg-2\">\n                              <div class=\"form-group form-group-sm\">\n                                  <label class=\"form-control-label\" for=\"for\">Monto:</label>\n                                  <div>\n                                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onMontoIgual()\">\n                                          <span aria-hidden=\"true\" class=\"glyphicon glyphicon-retweet\"></span>\n                                          Igual\n                                      </button>\n                                  </div>\n                              </div>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-lg-6\">\n                              <azteca-form-field [label]=\"'Tipo de Partida:'\">\n                                  <az-combobox formControlName=\"tiposPartidas\"\n                                               [(ngModel)]=\"presupuesto.tipoPartida\"\n                                               [items]=\"tiposPartidas\"\n                                               [valueMember]=\"'tipoPartida'\"\n                                               [displayMember]=\"'nombre'\"\n                                               (selectedItemChanged)=\"onSelectedTipoPartida($event)\">\n                                  </az-combobox>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div *ngIf=\"presupuesto.tipoPartida != 'E' \" class=\"row\">\n                          <div class=\"col-12 col-lg-3\">\n                              <azteca-form-field [label]=\"'Fecha Inicio:'\">\n                                  <az-input-date formControlName=\"fechaIni\"\n                                                 [(ngModel)]=\"presupuesto.fechaIni\"></az-input-date>\n                              </azteca-form-field>\n                          </div>\n\n                          <div class=\"col-12 col-lg-3\">\n                              <azteca-form-field [label]=\"'Fecha Final:'\">\n                                  <az-input-date formControlName=\"fechaFin\"\n                                                 [(ngModel)]=\"presupuesto.fechaFin\"></az-input-date>\n                              </azteca-form-field>\n                          </div>\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-lg-6\">\n                              <button *ngIf=\"presupuesto.tipoPartida != 'E'\" type=\"button\" class=\"btn btn-primary\" (click)=\"onAgregarPartida()\">\n                                  <span aria-hidden=\"true\" class=\"glyphicon glyphicon-plus\"></span>\n                                  Partida\n                              </button>\n                          </div>\n\n                          <div class=\"col-12 col-lg-6\">\n                              <button type=\"button\" class=\"btn btn-primary\" (click)=\"onAgregarCategoria()\">\n                                  <span aria-hidden=\"true\" class=\"glyphicon glyphicon-plus\"></span>\n                                  Categor&iacute;a\n                              </button>\n                          </div>\n\n                      </div>\n\n                      <div class=\"row\">\n                          <div class=\"col-12 col-lg-6\">\n                              <wj-flex-grid [itemsSource]=\"dataPartidas\">\n                                  <wj-flex-grid-column [header]=\"'Partida'\" [binding]=\"'nombre'\" [width]=\"'*'\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Monto'\" [binding]=\"'montoPresupuesto'\" [format]=\"'n2'\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Utilizado'\" [binding]=\"'montoUtilizado'\" [format]=\"'n2'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                              </wj-flex-grid>\n                          </div>\n\n                          <div class=\"col-12 col-lg-6\">\n                              <wj-flex-grid [itemsSource]=\"dataCategorias\">\n                                  <wj-flex-grid-column [header]=\"'Categor&iacute;a'\" [binding]=\"'nombre'\" [width]=\"'*'\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Monto'\" [binding]=\"'montoPresupuesto'\" [format]=\"'n2'\"></wj-flex-grid-column>\n                                  <wj-flex-grid-column [header]=\"'Utilizado'\" [binding]=\"'montoUtilizado'\" [format]=\"'n2'\" [isReadOnly]=\"true\"></wj-flex-grid-column>\n                              </wj-flex-grid>\n                          </div>\n\n                      </div>\n\n                  </az-panel>\n              </div>\n          </div>\n\n      </form>\n\n      <purchasing-categoria-presupuestal-list #dlgCategoriaPresupuestal\n                                              [multiSelect]=\"true\"\n                                              (articulosSelected)=\"onSelectedArticulos($event)\"\n                                              (articulosDeleted)=\"onDeletedArticulo($event)\">\n      </purchasing-categoria-presupuestal-list>\n\n      <!--DIALOGO DE CONFIRMACION-->\n      <div bsModal #dlgPartida=\"bs-modal\" class=\"modal fade\" tabindex=\"-1\" role=\"dialog\" aria-hidden=\"true\">\n          <div class=\"modal-dialog\">\n              <div class=\"modal-content\">\n                  <div class=\"modal-header\">\n                      <h5 class=\"modal-title\" id=\"exampleModalLabel\">Agregar Partida</h5>\n                      <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\" (click)=\"onCancelarPartida()\">\n                          <span aria-hidden=\"true\">&times;</span>\n                      </button>\n                  </div>\n                  <div class=\"modal-body\">\n                \n                      <form [formGroup]=\"formPresupuesto\">\n\n                          <div class=\"row\"><\n                              <div class=\"col-12\">\n                                  <azteca-form-field [label]=\"'Nombre:'\">\n                                      <az-textbox formControlName=\"nombre\"\n                                                  [(ngModel)]=\"partida.nombre\"></az-textbox>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n\n                          <div class=\"col-12\">\n                              <azteca-form-field [label]=\"'Presupuesto:'\">\n                                  <az-input-number formControlName=\"montoPresupuesto\"\n                                                   [format]=\"n2\"\n                                                   [(ngModel)]=\"partida.montoPresupuesto\"></az-input-number>\n                              </azteca-form-field>\n                          </div>\n\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <azteca-form-field [label]=\"'Fecha Inicio:'\">\n                                      <az-input-date formControlName=\"fechaIni\"\n                                                     [(ngModel)]=\"partida.fechaIni\"></az-input-date>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n\n                          <div class=\"row\">\n                              <div class=\"col-12\">\n                                  <azteca-form-field [label]=\"'Fecha Final:'\">\n                                      <az-input-date formControlName=\"fechaFin\"\n                                                     [(ngModel)]=\"partida.fechaFin\"></az-input-date>\n                                  </azteca-form-field>\n                              </div>\n                          </div>\n                      </form>\n                  </div>\n                  <div class=\"modal-footer\">\n                      <button type=\"button\" class=\"btn\" (click)=\"onCancelarPartida()\">\n                          <span aria-hidden=\"true\" class=\"glyphicon glyphicon-remove\"></span>\n                          Cancelar\n                      </button>\n                      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onAceptarPartida()\">\n                          <span aria-hidden=\"true\" class=\"glyphicon glyphicon-ok\"></span>\n                          Aceptar\n                      </button>\n                  </div>\n              </div>\n          </div>\n      </div>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return PresupuestosEditor_1; })
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.DocumentTypeService,
            presupuesto_service_1.PresupuestoService])
    ], PresupuestosEditor);
    return PresupuestosEditor;
}(controls_1.BaseControl));
exports.PresupuestosEditor = PresupuestosEditor;
