import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo } from 'framework3/core';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { DetailQuantityEditor } from '../../inventory';
import { RecepcionInfo } from '../models/recepcion';
import { RecepcionDetail } from '../models/recepcion-detail';
import { RecepcionArticuloDetail } from '../models/recepcion-articulo-detail';
import { RecepcionServicioDetail } from '../models/recepcion-servicio-detail';
import { RecepcionService } from '../services/recepcion.service';
import { RecepcionArticulosDetailEditor } from './parts/recepcion-articulos-detail.editor';
import { RecepcionServiciosDetailEditor } from './parts/recepcion-servicios-detail.editor';
import { ImportesInfo } from '../../accounting/models/importes';
import { CentroRecepcionService } from '../services/centro-recepcion.service';
import { CentroRecepcionInfo } from '../models/centro-recepcion';
import { OrdenService } from '../services/orden.service';
import { OrdenInfo } from '../models/orden';
import { OrdenDetail } from '../models/orden-detail';
import { ComprobanteFiscalInfo, ComprobanteFiscalItem } from '../../accounting/models/comprobante-fiscal';
import { ComprobanteFiscalService } from '../../accounting/services/comprobante-fiscal.service';
import { ComprobantesListComponent } from '../../accounting/components/comprobantes-dialog.component';
export declare class RecepcionesEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private recepcionService;
    private ordenService;
    private centroRecepcionService;
    private comprobanteFiscalService;
    recepcion: RecepcionInfo;
    orden: OrdenInfo;
    comprobante: ComprobanteFiscalInfo;
    centroRecepcion: CentroRecepcionInfo;
    idAlmacen: number;
    articulos: RecepcionArticuloDetail[];
    servicios: RecepcionServicioDetail[];
    articulosList: EditableListComponent;
    serviciosList: EditableListComponent;
    articulosEditor: RecepcionArticulosDetailEditor;
    serviciosEditor: RecepcionServiciosDetailEditor;
    comprobantesList: ComprobantesListComponent;
    quantityEditor: DetailQuantityEditor;
    readonly diferencia: string;
    readonly importes: ImportesInfo;
    readonly importesComprobante: ImportesInfo;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, recepcionService: RecepcionService, ordenService: OrdenService, centroRecepcionService: CentroRecepcionService, comprobanteFiscalService: ComprobanteFiscalService);
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
    onAddingArticulo(): void;
    onEditingArticulo(detail: RecepcionArticuloDetail): void;
    onDeletingArticulo(detail: RecepcionArticuloDetail): void;
    onArticulosUpdated(updatedItems: RecepcionArticuloDetail[]): void;
    onSavingArticulo(detail: RecepcionArticuloDetail): void;
    onSavingArticulos(details: RecepcionArticuloDetail[]): void;
    onUpdateQuantity(value: any): void;
    onAddingServicio(): void;
    onEditingServicio(detail: RecepcionServicioDetail): void;
    onDeletingServicio(detail: RecepcionDetail): void;
    onServiciosUpdated(updatedServices: RecepcionServicioDetail[]): void;
    onSavingServicio(detail: RecepcionServicioDetail): void;
    onSavingServicios(details: RecepcionServicioDetail[]): void;
    cargarInfomacionEntidades(): void;
    parseArticulo(item: OrdenDetail): RecepcionArticuloDetail;
    parseServicio(item: OrdenDetail): RecepcionServicioDetail;
    private refreshValidity;
    combineDetail(): RecepcionDetail[];
    importesDesglosados(): ImportesInfo;
    addAsociar(): void;
    onComprobanteSelected(comprobanteItem: ComprobanteFiscalItem): void;
}
