"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Locales
var inventory_1 = require("../../inventory");
//
var recepcion_1 = require("../models/recepcion");
var recepcion_articulo_detail_1 = require("../models/recepcion-articulo-detail");
var recepcion_servicio_detail_1 = require("../models/recepcion-servicio-detail");
var recepcion_service_1 = require("../services/recepcion.service");
//import { RecepcionDetailEditor } from './parts/recepciones-detail.editor';
var recepcion_articulos_detail_editor_1 = require("./parts/recepcion-articulos-detail.editor");
var recepcion_servicios_detail_editor_1 = require("./parts/recepcion-servicios-detail.editor");
var importes_1 = require("../../accounting/models/importes");
var centro_recepcion_service_1 = require("../services/centro-recepcion.service");
var centro_recepcion_1 = require("../models/centro-recepcion");
var orden_service_1 = require("../services/orden.service");
var orden_1 = require("../models/orden");
var comprobante_fiscal_service_1 = require("../../accounting/services/comprobante-fiscal.service");
var comprobantes_dialog_component_1 = require("../../accounting/components/comprobantes-dialog.component");
var RecepcionesEditor = /** @class */ (function (_super) {
    __extends(RecepcionesEditor, _super);
    function RecepcionesEditor(context, router, route, location, formBuilder, documentTypeService, recepcionService, ordenService, centroRecepcionService, comprobanteFiscalService) {
        var _this = _super.call(this, context, router, route, documentTypeService) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.documentTypeService = documentTypeService;
        _this.recepcionService = recepcionService;
        _this.ordenService = ordenService;
        _this.centroRecepcionService = centroRecepcionService;
        _this.comprobanteFiscalService = comprobanteFiscalService;
        _this.recepcion = new recepcion_1.RecepcionInfo();
        _this.orden = new orden_1.OrdenInfo();
        _this.centroRecepcion = new centro_recepcion_1.CentroRecepcionInfo();
        _this.idAlmacen = 0;
        //
        _this.articulos = [];
        _this.servicios = []; //
        _this.documentForm = formBuilder.group({
            'sample': ['', forms_1.Validators.required],
        });
        return _this;
    }
    RecepcionesEditor_1 = RecepcionesEditor;
    Object.defineProperty(RecepcionesEditor.prototype, "diferencia", {
        get: function () {
            var color = "red";
            if (this.comprobante)
                if (this.recepcion.total == this.comprobante.total)
                    color = "green";
            return color;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RecepcionesEditor.prototype, "importes", {
        get: function () {
            return this.importesDesglosados();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(RecepcionesEditor.prototype, "importesComprobante", {
        get: function () {
            var desglose = new importes_1.ImportesInfo();
            if (this.comprobante) {
                desglose.total = this.comprobante.total;
                desglose.subtotal = this.comprobante.subTotal;
                desglose.descuentos = this.comprobante.descuentos;
                desglose.impuestosTrasladados = this.comprobante.impuestos.totalTraslados;
                desglose.impuestosRetenidos = this.comprobante.impuestos.totalRetenciones;
            }
            return desglose;
        },
        enumerable: true,
        configurable: true
    });
    RecepcionesEditor.prototype.onConfigureDocument = function (docType) {
        this.applyPolicies();
    };
    RecepcionesEditor.prototype.onCreatingDocument = function () {
        var _this = this;
        this.articulos = [];
        this.servicios = [];
        //Cargar parámetros que se proporcionan cuando es un nuevo documento
        this.route.params.forEach(function (params) {
            _this.recepcion.idCentroRecepcion = +params['idCentroRecepcion'];
            _this.recepcion.idOrdenTit = params['idOrden'];
        });
        setTimeout(function (_) { return _this.cargarInfomacionEntidades(); });
    };
    RecepcionesEditor.prototype.onViewingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.recepcionService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.recepcion = doc;
            _this.setReadonlyMode();
            _this.articulos = _this.recepcion.details.map(function (d) { return d; }).filter(function (d) { return d.idArticulo && d.idArticulo > 0; });
            _this.servicios = _this.recepcion.details.map(function (d) { return d; }).filter(function (d) { return d.idServicio && d.idServicio > 0; });
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RecepcionesEditor.prototype.onCloningDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.recepcionService.clone(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.recepcion = doc;
            //
            _this.articulos = _this.recepcion.details.map(function (d) { return d; }).filter(function (d) { return d.idArticulo && d.idArticulo > 0; });
            _this.servicios = _this.recepcion.details.map(function (d) { return d; }).filter(function (d) { return d.idServicio && d.idServicio > 0; });
            //
            //this.detailsEditor.clientIndexStart = this.articulos.length;
            _this.articulosEditor.clientIndexStart = _this.articulos.length;
            _this.serviciosEditor.clientIndexStart = _this.servicios.length;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RecepcionesEditor.prototype.onLoadingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.recepcionService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.recepcion = doc;
            //
            _this.articulos = _this.recepcion.details.map(function (d) { return d; }).filter(function (d) { return d.idArticulo && d.idArticulo > 0; });
            _this.servicios = _this.recepcion.details.map(function (d) { return d; }).filter(function (d) { return d.idServicio && d.idServicio > 0; });
            //
            //this.detailsEditor.clientIndexStart = this.articulos.length + this.servicios.length;
            _this.articulosEditor.clientIndexStart = _this.articulos.length;
            _this.serviciosEditor.clientIndexStart = _this.servicios.length;
            if (_this.recepcion.status != core_2.DocumentStatus.DRAFT)
                _this.setReadonlyMode();
            setTimeout(function (_) { return _this.refreshValidity(); });
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RecepcionesEditor.prototype.onSavingDocument = function (args) {
        var _this = this;
        //this.argsEditorEvent = args;
        this.context.app.showSpinner();
        this.recepcion.details = this.combineDetail();
        this.recepcionService.update(this.recepcion)
            .then(function (updatedDoc) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.recepcion.identity == '') {
                _this.router.navigate(['../', updatedDoc.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.recepcion = updatedDoc;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RecepcionesEditor.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.recepcionService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(args.document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RecepcionesEditor.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.recepcionService.previousStep(document.id, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RecepcionesEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Al seleccionar la pestaña de historial, realizar carga de información
            if (args.heading == 'Historial') {
                this.loadHistory(this.recepcion.identity);
            }
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    ///////////// DETALLE DEL DOCUMENTO /////////////////////////
    //onAddingDetail() {
    //    this.detailsEditor.detail = new RecepcionDetail();
    //    this.detailsEditor.show();
    //}
    //onEditingDetail(detail: RecepcionDetail) {
    //    this.detailsEditor.detail = detail;
    //    this.detailsEditor.show();
    //}
    //onDeletingDetail(detail: RecepcionDetail) {
    //    this.detailsList.deleteItem(detail);
    //}
    //onListItemsUpdated(updatedDetails: RecepcionDetail[]) {
    //    this.recepcion.details = updatedDetails;
    //}
    //onSavingDetail(detail: RecepcionDetail) {
    //    this.detailsList.updateItem(detail);
    //}
    ///////////// ARTICULOS /////////////////////////
    RecepcionesEditor.prototype.onAddingArticulo = function () {
        this.articulosEditor.detail = new recepcion_articulo_detail_1.RecepcionArticuloDetail();
        this.articulosEditor.show();
    };
    RecepcionesEditor.prototype.onEditingArticulo = function (detail) {
        this.articulosEditor.detail = detail;
        this.articulosEditor.onLoadingItem(detail);
        this.articulosEditor.show();
        //this.quantityEditor.unidadMedida = detail.unidadMedida;
        //this.quantityEditor.cantidad = detail.cantidad;
        //this.quantityEditor.unidades = detail.unidades;
        //this.quantityEditor.show();
    };
    RecepcionesEditor.prototype.onDeletingArticulo = function (detail) {
        this.articulosList.deleteItem(detail);
    };
    RecepcionesEditor.prototype.onArticulosUpdated = function (updatedItems) {
        this.articulos = updatedItems;
    };
    RecepcionesEditor.prototype.onSavingArticulo = function (detail) {
        this.articulosList.updateItem(detail);
    };
    RecepcionesEditor.prototype.onSavingArticulos = function (details) {
        this.articulosList.updateItems(details);
    };
    RecepcionesEditor.prototype.onUpdateQuantity = function (value) {
        var detail = this.articulosList.currentItem;
        if (detail.unidadMedida.paquete) {
            var cantidad = value;
            detail.cantidad = cantidad.paquetes;
            detail.unidades = cantidad.unidades;
        }
        else {
            detail.cantidad = value;
        }
        this.articulosList.updateItem(detail);
    };
    ///////////// SERVICIOS /////////////////////////
    RecepcionesEditor.prototype.onAddingServicio = function () {
        this.serviciosEditor.detail = new recepcion_servicio_detail_1.RecepcionServicioDetail();
        this.serviciosEditor.show();
    };
    RecepcionesEditor.prototype.onEditingServicio = function (detail) {
        this.serviciosEditor.detail = detail;
        this.serviciosEditor.show();
    };
    RecepcionesEditor.prototype.onDeletingServicio = function (detail) {
        this.serviciosList.deleteItem(detail);
    };
    RecepcionesEditor.prototype.onServiciosUpdated = function (updatedServices) {
        this.servicios = updatedServices;
    };
    RecepcionesEditor.prototype.onSavingServicio = function (detail) {
        this.serviciosList.updateItem(detail);
    };
    RecepcionesEditor.prototype.onSavingServicios = function (details) {
        this.serviciosList.updateItems(details);
    };
    //
    ///metodos locales
    RecepcionesEditor.prototype.cargarInfomacionEntidades = function () {
        //this.proveedorService.getDetailByID(this.recepcion.idProveedor)
        //    .then(proveedor => {
        //        this.recepcion.proveedor = proveedor;
        //    })
        //    .catch(error => this.handleError(error));
        var _this = this;
        this.ordenService.getDetail(this.recepcion.idOrdenTit)
            .then(function (orden) {
            _this.orden = orden;
            var articulos = [];
            var servicios = []; //
            //Cargamos los articulos con saldo
            _this.orden.details.map(function (d) { return d; }).filter(function (d) { return d.idArticulo && d.idArticulo > 0 && d.saldo > 0; })
                .forEach(function (item) {
                //Vemos a ver si maneja series
                if (item.articulo.articuloStock.manejaSeries) {
                    for (var count = 1; count <= item.saldo; count++) {
                        var newArt = _this.parseArticulo(item);
                        newArt._clientID = articulos.length + 1;
                        articulos.push(newArt);
                    }
                }
                else {
                    var newArt = _this.parseArticulo(item);
                    newArt._clientID = articulos.length + 1;
                    articulos.push(newArt);
                }
            });
            // cargamos los servicios pendientes de la orden
            _this.orden.details.map(function (d) { return d; }).filter(function (d) { return d.idServicio && d.idServicio > 0 && d.saldo > 0; })
                .forEach(function (item) {
                var newSvc = _this.parseServicio(item);
                newSvc._clientID = servicios.length + 1;
                servicios.push(newSvc);
            });
            //
            _this.articulos = articulos;
            _this.servicios = servicios;
            _this.articulosList.updateItems(articulos);
            _this.serviciosList.updateItems(servicios);
            //
            _this.centroRecepcionService.getDetailByID(_this.recepcion.idCentroRecepcion)
                .then(function (centro) {
                _this.centroRecepcion = centro;
                _this.idAlmacen = centro.idAlmacen;
            })
                .catch(function (error) { return _this.handleError(error); });
            setTimeout(function (_) { return _this.refreshValidity(); });
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RecepcionesEditor.prototype.parseArticulo = function (item) {
        var detail = new recepcion_articulo_detail_1.RecepcionArticuloDetail();
        detail._clientID = this.articulos.length + 1;
        var cantidad = item.saldo;
        if (item.articulo.articuloStock.manejaSeries) {
            cantidad = 1;
        }
        detail.state = 'ADDED';
        detail.idArticulo = item.idArticulo;
        detail.articulo = item.articulo, detail.cantidad = cantidad;
        detail.unidades = 0;
        detail.idUnidadMedida = item.idUnidadMedida;
        detail.unidadMedida = item.unidadMedida;
        detail.costoUnitario = item.costoUnitario;
        detail.costoNeto = item.costoNeto;
        detail.importe = cantidad * item.costoUnitario, detail.descuentos = item.descuentos;
        detail.impuestos = item.impuestos;
        return detail;
    };
    RecepcionesEditor.prototype.parseServicio = function (item) {
        var detail = new recepcion_servicio_detail_1.RecepcionServicioDetail();
        detail._clientID = this.servicios.length + 1;
        detail.state = 'ADDED';
        detail.idServicio = item.idServicio;
        detail.servicio = item.servicio, detail.cantidad = item.saldo;
        detail.idUnidadMedida = item.idUnidadMedida;
        detail.unidadMedida = item.unidadMedida;
        detail.costoUnitario = item.costoUnitario;
        detail.costoNeto = item.costoNeto;
        detail.importe = item.importe, detail.descuentos = item.descuentos;
        detail.impuestos = item.impuestos;
        return detail;
    };
    RecepcionesEditor.prototype.refreshValidity = function () {
        this.editor.valid = this.documentForm.valid;
    };
    RecepcionesEditor.prototype.combineDetail = function () {
        var newDetail = [];
        this.servicios.forEach(function (s) { return newDetail.push(s); });
        this.articulos.forEach(function (a) { return newDetail.push(a); });
        return newDetail;
    };
    RecepcionesEditor.prototype.importesDesglosados = function () {
        var desglose = new importes_1.ImportesInfo();
        var elementos = this.combineDetail().filter(function (item) { return item.state != 'DELETED'; });
        elementos.forEach(function (item) {
            desglose.subtotal += item.costoUnitario * item.cantidad;
            desglose.descuentos += (item.descuentos.descuento1 + item.descuentos.descuento2 + item.descuentos.descuento3 + item.descuentos.descuento4 + item.descuentos.descuento5) * item.cantidad;
            if (item.impuestos.filter(function (tras) { return tras.tipoAplicacion == "T"; }).length > 0)
                desglose.impuestosTrasladados += item.impuestos.filter(function (tras) { return tras.tipoAplicacion == "T"; }).map(function (imp) { return imp.importe * item.cantidad; }).reduce(function (a, b) { return a + b; });
            if (item.impuestos.filter(function (tras) { return tras.tipoAplicacion == "R"; }).length > 0)
                desglose.impuestosRetenidos += item.impuestos.filter(function (tras) { return tras.tipoAplicacion == "R"; }).map(function (imp) { return imp.importe * item.cantidad; }).reduce(function (a, b) { return a + b; });
        });
        desglose.total = desglose.subtotal - desglose.descuentos + desglose.impuestosTrasladados - desglose.impuestosRetenidos;
        return desglose;
    };
    RecepcionesEditor.prototype.addAsociar = function () {
        //this.comprobantesList.config.backdrop = false;
        this.comprobantesList.show();
    };
    RecepcionesEditor.prototype.onComprobanteSelected = function (comprobanteItem) {
        var _this = this;
        this.comprobanteFiscalService.getDetail(comprobanteItem.id)
            .then(function (item) {
            _this.comprobante = item;
            //      this.comprobantesList.hide;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    var RecepcionesEditor_1;
    __decorate([
        core_1.ViewChild('articulosList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], RecepcionesEditor.prototype, "articulosList", void 0);
    __decorate([
        core_1.ViewChild('serviciosList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], RecepcionesEditor.prototype, "serviciosList", void 0);
    __decorate([
        core_1.ViewChild('articulosEditor'),
        __metadata("design:type", recepcion_articulos_detail_editor_1.RecepcionArticulosDetailEditor)
    ], RecepcionesEditor.prototype, "articulosEditor", void 0);
    __decorate([
        core_1.ViewChild('serviciosEditor'),
        __metadata("design:type", recepcion_servicios_detail_editor_1.RecepcionServiciosDetailEditor)
    ], RecepcionesEditor.prototype, "serviciosEditor", void 0);
    __decorate([
        core_1.ViewChild('comprobantesList'),
        __metadata("design:type", comprobantes_dialog_component_1.ComprobantesListComponent)
    ], RecepcionesEditor.prototype, "comprobantesList", void 0);
    __decorate([
        core_1.ViewChild(inventory_1.DetailQuantityEditor),
        __metadata("design:type", inventory_1.DetailQuantityEditor)
    ], RecepcionesEditor.prototype, "quantityEditor", void 0);
    RecepcionesEditor = RecepcionesEditor_1 = __decorate([
        core_1.Component({
            selector: 'compras-recepciones-editor',
            template: "\n      <form [formGroup]=\"documentForm\">\n          <azteca-document-editor #documentEditor\n                                  [title]=\"'Recepciones'\"\n                                  [document]=\"recepcion\"\n                                  [valid]=\"valid\"\n                                  (configureDocument)=\"onConfigureDocument($event)\"\n                                  (creatingDocument)=\"onCreatingDocument()\"\n                                  (viewingDocument)=\"onViewingDocument($event)\"\n                                  (cloningDocument)=\"onCloningDocument($event)\"\n                                  (savingDocument)=\"onSavingDocument($event)\"\n                                  (loadingDocument)=\"onLoadingDocument($event)\"\n                                  (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                  (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n              <!------------------- Controles del editor ----------------------------->\n\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-7\">\n                      <label class=\"control-label\">Proveedor:</label>\n                      <az-label [text]=\"orden.proveedor ? orden.proveedor.code + '-' + orden.proveedor.nombre : ''\"></az-label>\n                  </div>\n                  <div class=\"col-12 col-md-3\">\n                      <label class=\"control-label\">Centro de recepcion:</label>\n                      <az-label [text]=\"centroRecepcion ? centroRecepcion.code + '-' + centroRecepcion.nombre : ''\"></az-label>\n                  </div>\n              </div>\n\n              <div class=\"row\" style=\"top:10px; padding-top:10px; padding-bottom:10px\">\n                  <div class=\"col-sm-12 col-md-3\">\n                      <accounting-importes-component [importes]=\"importes\"\n                                                     [titulo]=\"'Importes recibido'\">\n                      </accounting-importes-component>\n                  </div>\n                  <div class=\"col-sm-12 col-md-1\">\n                      <div class=\"row\">\n                          <div class=\"col-12\">\n                              <button type=\"submit\" class=\"btn btn-primary\" (click)=\"addAsociar()\" [ngStyle]=\"{'background-color': diferencia}\">\n                                  <span class=\"glyphicon glyphicon-plus\" aria-hidden=\"true\"></span>Asociar\n                              </button>\n                          </div>\n                      </div>\n                  </div>\n                  <div class=\"col-sm-12 col-md-3\">\n                      <accounting-importes-component [importes]=\"importesComprobante\"\n                                                     [titulo]=\"'Importes del Comprobante Fiscal'\">\n                      </accounting-importes-component>\n                  </div>\n              </div>\n\n\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n\n                      <tabset>\n                          <!--ARTICULOS -->\n                          <tab heading=\"Art\u00EDculos\" (select)=\"onTabSelected($event)\">\n                              <azteca-editable-list #articulosList\n                                                    (addingItem)=\"onAddingArticulo()\"\n                                                    (editingItem)=\"onEditingArticulo($event)\"\n                                                    (deletingItem)=\"onDeletingArticulo($event)\"\n                                                    (listItemsUpdated)=\"onArticulosUpdated($event)\"\n                                                    [listItems]=\"articulos\"\n                                                    [allowNew]=\"false\"\n                                                    [allowDelete]=\"false\">\n\n                                  <!-- OPCIONES DEL MENU-->\n                                  <azteca-menu-item [name]=\"'EDIT'\" [icon]=\"'glyphicon glyphicon-pencil'\" [text]=\"'Editar'\" [smallText]=\"'editar art\u00EDculo'\"></azteca-menu-item>\n                                  <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar art\u00EDculo'\"></azteca-menu-item>\n\n                                  <!-- COLUMNAS DEL GRID-->\n                                  <azteca-grid-column [header]=\"'Descripci\u00F3n'\" [binding]=\"'articulo.articuloStock.nombre'\" [width]=\"'50*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'U.M.'\" [binding]=\"'unidadMedida.nombre'\" [width]=\"'20*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Lote'\" [binding]=\"'idLote'\" [width]=\"80\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Num. Serie'\" [binding]=\"'numSerie'\" [width]=\"'30*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Cantidad'\" [binding]=\"'cantidad'\" [width]=\"'10*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Unidades'\" [binding]=\"'unidades'\" [width]=\"'10*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Precio'\" [binding]=\"'costoUnitario'\" [width]=\"'10*'\" format=\"C\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Importe'\" [binding]=\"'importe'\" [width]=\"'20*'\" format=\"C\"></azteca-grid-column>\n                              </azteca-editable-list>\n                          </tab>\n\n                          <!--SERVICIOS -->\n                          <tab heading=\"Servicios\" (select)=\"onTabSelected($event)\">\n                              <azteca-editable-list #serviciosList\n                                                    (addingItem)=\"onAddingServicio()\"\n                                                    (editingItem)=\"onEditingServicio($event)\"\n                                                    (deletingItem)=\"onDeletingServicio($event)\"\n                                                    (listItemsUpdated)=\"onServiciosUpdated($event)\"\n                                                    [listItems]=\"servicios\"\n                                                    [allowNew]=\"false\"\n                                                    [allowDelete]=\"false\">\n\n                                  <!-- OPCIONES DEL MENU-->\n                                  <azteca-menu-item [name]=\"'EDIT'\" [icon]=\"'glyphicon glyphicon-pencil'\" [text]=\"'Editar'\" [smallText]=\"'editar servicio'\"></azteca-menu-item>\n                                  <azteca-menu-item [name]=\"'DELETE'\" [icon]=\"'glyphicon glyphicon-trash'\" [text]=\"'Eliminar'\" [smallText]=\"'eliminar servicio'\"></azteca-menu-item>\n\n                                  <!-- COLUMNAS DEL GRID-->\n                                  <azteca-grid-column [header]=\"'C\u00F3digo'\" [binding]=\"'servicio.code'\" [width]=\"100\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Descripci\u00F3n'\" [binding]=\"'servicio.nombre'\" [width]=\"'5*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Cantidad'\" [binding]=\"'cantidad'\" [width]=\"'1*'\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Costo'\" [binding]=\"'costoUnitario'\" [width]=\"'1*'\" format=\"C\"></azteca-grid-column>\n                                  <azteca-grid-column [header]=\"'Importe'\" [binding]=\"'importe'\" [width]=\"'1*'\" format=\"C\"></azteca-grid-column>\n\n                              </azteca-editable-list>\n                          </tab>\n\n                          <tab heading=\"Historial\" (select)=\"onTabSelected($event)\" [disabled]=\"recepcion.identity==''\">\n                              <document-history [history]=\"history\"></document-history>\n                          </tab>\n\n                      </tabset>\n\n                  </div>\n              </div>\n          </azteca-document-editor>\n      </form>\n\n\n      <!--<compras-recepcion-detail-editor #detailsEditor\n                                       [idAlmacen]=\"idAlmacen\"\n                                       (savingItem)=\"onSavingDetail($event)\">\n\n      </compras-recepcion-detail-editor>-->\n\n      <compras-recepcion-articulos-detail-editor #articulosEditor\n                                                 [idAlmacen]=\"idAlmacen\"\n                                                 (savingItem)=\"onSavingArticulo($event)\"\n                                                 (savingItems)=\"onSavingArticulos($event)\">\n      </compras-recepcion-articulos-detail-editor>\n\n      <compras-recepcion-servicios-detail-editor #serviciosEditor\n                                                 (savingItem)=\"onSavingServicio($event)\"\n                                                 (savingItems)=\"onSavingServicios($event)\">\n      </compras-recepcion-servicios-detail-editor>\n\n      <accounting-comprobantes-list #comprobantesList\n                                    (selectedItemChanged)=\"onComprobanteSelected($event)\"\n                                    [idContribuyente]=\"orden.proveedor.contribuyente ? orden.proveedor.contribuyente.identity : 0\"\n                                    [idComprobanteTipo]=\"2\"\n                                    [Activos]=\"true\"\n                                    [sinReferencia]=\"true\">\n      </accounting-comprobantes-list>\n\n      <inventario-detail-quantity (updateQuantity)=\"onUpdateQuantity($event)\">\n\n      </inventario-detail-quantity>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return RecepcionesEditor_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: recepcion_service_1.RecepcionService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.DocumentTypeService,
            recepcion_service_1.RecepcionService,
            orden_service_1.OrdenService,
            centro_recepcion_service_1.CentroRecepcionService,
            comprobante_fiscal_service_1.ComprobanteFiscalService])
    ], RecepcionesEditor);
    return RecepcionesEditor;
}(editors_1.DocumentEditor));
exports.RecepcionesEditor = RecepcionesEditor;
