import { Router, ActivatedRoute } from '@angular/router';
import { Context, DocumentItem } from 'framework3/core';
import { DocumentManager, WorkflowEventArgs } from 'framework3/editors';
import { SearchRequest } from 'framework3/search';
import { OrdenItem } from '../models/orden';
import { RecepcionItem } from '../models/recepcion';
import { RecepcionService } from '../services/recepcion.service';
import { ModalDirective } from 'ngx-bootstrap';
import { CentralService } from '../services/central.service';
import { CentroRecepcionItem } from '../models/centro-recepcion';
import { OrdenesListComponent } from '../dialogs/ordenes-list.component';
export declare class RecepcionesManager extends DocumentManager {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private recepcionService;
    private centralService;
    recepciones: RecepcionItem[];
    idProveedor: number;
    idCentroRecepcion: number;
    centrosRecepcion: CentroRecepcionItem[];
    ordenesList: OrdenesListComponent;
    proveedorDialog: ModalDirective;
    constructor(context: Context, router: Router, route: ActivatedRoute, recepcionService: RecepcionService, centralService: CentralService);
    onConfigureDocument(): void;
    onSearchRequested(request: SearchRequest): void;
    onAddingItem(): void;
    onViewingItem(document: DocumentItem): void;
    onEditingItem(document: DocumentItem): void;
    onDeletingItem(document: DocumentItem): void;
    onCloningItem(document: DocumentItem): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    loadCentrales(): void;
    onProveedorSelected(): void;
    onOrdenSelected(orden: OrdenItem): void;
}
