import { Router, ActivatedRoute } from '@angular/router';
import { FormBuilder } from '@angular/forms';
import { Location } from '@angular/common';
import { Context, DocumentItem, DocumentTypeService, DocumentTypeInfo } from 'framework3/core';
import { DocumentEditor, EditableListComponent, EditorEventArgs, WorkflowEventArgs } from 'framework3/editors';
import { RequisicionInfo } from '../models/requisicion';
import { RequisicionDetail } from '../models/requisicion-detail';
import { RequisicionService } from '../services/requisicion.service';
import { RequisicionDetailEditor } from './parts/requisiciones-detail.editor';
import { DepartamentoItem } from '../models/departamento';
import { DepartamentoService } from '../services/departamento.service';
import { CentroRecepcionItem } from '../models/centro-recepcion';
import { CentroRecepcionService } from '../services/centro-recepcion.service';
import { ArticuloInfo } from '../models/articulo';
import { ArticuloService } from '../services/articulo.service';
import { PresupuestoService } from '../services/presupuesto.service';
import { PresupuestoItem, PresupuestoInfo } from '../models/presupuesto';
import { CentralItem } from '../models/central';
import { CentralService } from '../services/central.service';
import { SecurityContext } from '../models/security-context';
import { UnidadMedidaItem, UnidadMedidaService } from '../../inventory';
export declare class RequisicionesEditor extends DocumentEditor {
    protected context: Context;
    protected router: Router;
    protected route: ActivatedRoute;
    private location;
    private formBuilder;
    protected documentTypeService: DocumentTypeService;
    private requisicionService;
    private departamentoService;
    private centroRecepcionService;
    private unidadMedidaService;
    private articuloService;
    private presupuestoService;
    private centralService;
    requisicion: RequisicionInfo;
    idGrupoRequisicion: string;
    requisicionesTipo: {
        id: number;
        name: string;
    }[];
    securityContext: SecurityContext[];
    centrales: CentralItem[];
    centrosRecepcion: CentroRecepcionItem[];
    departamentos: DepartamentoItem[];
    unidadesMedida: UnidadMedidaItem[];
    presupuestos: PresupuestoItem[];
    presupuesto: PresupuestoInfo;
    articuloServicio: string;
    articuloServicioItems: {
        id: string;
        nombre: string;
    }[];
    departamento: DepartamentoItem;
    articulo: ArticuloInfo;
    detailsList: EditableListComponent;
    detailsEditor: RequisicionDetailEditor;
    constructor(context: Context, router: Router, route: ActivatedRoute, location: Location, formBuilder: FormBuilder, documentTypeService: DocumentTypeService, requisicionService: RequisicionService, departamentoService: DepartamentoService, centroRecepcionService: CentroRecepcionService, unidadMedidaService: UnidadMedidaService, articuloService: ArticuloService, presupuestoService: PresupuestoService, centralService: CentralService);
    onConfigureDocument(docType: DocumentTypeInfo): void;
    onCreatingDocument(): void;
    onViewingDocument(id: string): void;
    onCloningDocument(id: string): void;
    onLoadingDocument(id: string): void;
    onSavingDocument(args: EditorEventArgs): void;
    onApplyingNextStep(args: WorkflowEventArgs): void;
    onApplyingPreviousStep(document: DocumentItem): void;
    onTabSelected(args: any): void;
    onCancelingEdit(): void;
    onAddingDetail(): void;
    onEditingDetail(detail: RequisicionDetail): void;
    onDeletingDetail(detail: RequisicionDetail): void;
    onListItemsUpdated(updatedDetails: RequisicionDetail[]): void;
    onSavingDetail(detail: RequisicionDetail): void;
    loadCentrales(): void;
    loadCentrosRecepcion(idCentral: number): void;
    loadDepartamentos(idCentroRecepcion: number): void;
    onArticuloChanged(articulo: ArticuloInfo): void;
    loadUnidadesMedida(idTipoUnidad: number): void;
}
