"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Wijmo
var wijmo_1 = require("wijmo/wijmo");
//Azteca Kernel
var core_2 = require("framework3/core");
var controls_1 = require("framework3/controls");
var editors_1 = require("framework3/editors");
//Locales
var requisicion_1 = require("../models/requisicion");
var requisicion_detail_1 = require("../models/requisicion-detail");
var requisicion_service_1 = require("../services/requisicion.service");
var requisiciones_detail_editor_1 = require("./parts/requisiciones-detail.editor");
var departamento_1 = require("../models/departamento");
var departamento_service_1 = require("../services/departamento.service");
var centro_recepcion_service_1 = require("../services/centro-recepcion.service");
var articulo_1 = require("../models/articulo");
var articulo_service_1 = require("../services/articulo.service");
var presupuesto_service_1 = require("../services/presupuesto.service");
var presupuesto_1 = require("../models/presupuesto");
var central_service_1 = require("../services/central.service");
var _ = require("lodash");
//Inventario
var inventory_1 = require("../../inventory");
var RequisicionesEditor = /** @class */ (function (_super) {
    __extends(RequisicionesEditor, _super);
    function RequisicionesEditor(context, router, route, location, formBuilder, documentTypeService, requisicionService, departamentoService, centroRecepcionService, unidadMedidaService, articuloService, presupuestoService, centralService) {
        var _this = _super.call(this, context, router, route, documentTypeService) || this;
        _this.context = context;
        _this.router = router;
        _this.route = route;
        _this.location = location;
        _this.formBuilder = formBuilder;
        _this.documentTypeService = documentTypeService;
        _this.requisicionService = requisicionService;
        _this.departamentoService = departamentoService;
        _this.centroRecepcionService = centroRecepcionService;
        _this.unidadMedidaService = unidadMedidaService;
        _this.articuloService = articuloService;
        _this.presupuestoService = presupuestoService;
        _this.centralService = centralService;
        _this.requisicion = new requisicion_1.RequisicionInfo();
        _this.idGrupoRequisicion = "";
        _this.requisicionesTipo = [];
        _this.securityContext = [];
        _this.centrales = [];
        _this.centrosRecepcion = [];
        _this.departamentos = [];
        _this.unidadesMedida = [];
        _this.presupuestos = [];
        _this.presupuesto = new presupuesto_1.PresupuestoInfo();
        _this.articuloServicio = "A";
        _this.articuloServicioItems = [
            { "id": 'A', "nombre": "Articulo" },
            { "id": 'S', "nombre": "Servicio" }
        ];
        //
        _this.departamento = new departamento_1.DepartamentoItem();
        _this.articulo = new articulo_1.ArticuloInfo();
        _this.documentForm = formBuilder.group({
            'idTipoRequisicion': [0],
            'idCentral': [0, controls_1.AztecaValidators.selected],
            'idDepartamento': [0, controls_1.AztecaValidators.selected],
            'idCentroRecepcion': [0, controls_1.AztecaValidators.selected],
            'articuloServicio': ['A', forms_1.Validators.required],
            'idArticulo': [0],
            'idServicio': [0],
            'cantidad': [0, forms_1.Validators.required],
            'idUnidadMedida': [0],
            'observaciones': [''],
            'idPresupuesto': [''],
            'idCategoriaPresupuestal': [''],
        });
        //Hacer requerido el método de valuación sólo cuando se manejen lotes
        _this.documentForm.controls['articuloServicio'].valueChanges.subscribe(function (value) {
            if (value == 'A') {
                _this.documentForm.controls['idArticulo'].setValidators(controls_1.AztecaValidators.selected);
                _this.documentForm.controls['idUnidadMedida'].setValidators(controls_1.AztecaValidators.selected);
                _this.documentForm.controls['idServicio'].setValue('');
                _this.documentForm.controls['idServicio'].setValidators(null);
            }
            else {
                _this.documentForm.controls['idServicio'].setValidators(controls_1.AztecaValidators.selected);
                _this.documentForm.controls['idArticulo'].setValue('');
                _this.documentForm.controls['idArticulo'].setValidators(null);
                _this.documentForm.controls['idUnidadMedida'].setValue('');
                _this.documentForm.controls['idUnidadMedida'].setValidators(null);
            }
            _this.documentForm.controls['idArticulo'].updateValueAndValidity();
            _this.documentForm.controls['idServicio'].updateValueAndValidity();
            _this.documentForm.controls['idUnidadMedida'].updateValueAndValidity();
        });
        return _this;
    }
    RequisicionesEditor_1 = RequisicionesEditor;
    RequisicionesEditor.prototype.onConfigureDocument = function (docType) {
        var _this = this;
        this.route.params.forEach(function (params) {
            _this.idGrupoRequisicion = params['idGrupoRequisicion'];
        });
        this.applyPolicies();
        this.loadCentrales();
    };
    RequisicionesEditor.prototype.onCreatingDocument = function () {
    };
    RequisicionesEditor.prototype.onViewingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.requisicionService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.requisicion = doc;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RequisicionesEditor.prototype.onCloningDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.requisicionService.clone(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.requisicion = doc;
            _this.detailsEditor.clientIndexStart = _this.requisicion.details.length;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RequisicionesEditor.prototype.onLoadingDocument = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.requisicionService.getDetail(id)
            .then(function (doc) {
            _this.context.app.hideSpinner();
            _this.loadCentrosRecepcion(doc.idDepartamento);
            _this.articuloServicio = doc.idArticulo > 0 ? 'A' : 'S';
            _this.requisicion = doc;
            _this.detailsEditor.clientIndexStart = _this.requisicion.details.length;
            if (_this.requisicion.status != core_2.DocumentStatus.DRAFT)
                _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RequisicionesEditor.prototype.onSavingDocument = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.requisicion.idGrupoRequisiciones = this.idGrupoRequisicion;
        if (this.articuloServicio == 'A')
            this.requisicion.idServicio = 0;
        if (this.articuloServicio == 'S')
            this.requisicion.idArticulo = 0;
        this.requisicionService.update(this.requisicion)
            .then(function (updatedDoc) {
            _this.context.app.hideSpinner();
            //Si es un elemento nuevo y no se cerrará el editor, navegar a nueva ruta
            _this.reset();
            if (!args.closeEditor && _this.requisicion.identity == '') {
                _this.router.navigate(['../', updatedDoc.identity], { relativeTo: _this.route });
            }
            else {
                if (args.closeEditor)
                    _this.router.navigate(['../'], { relativeTo: _this.route });
                else
                    _this.showAlert('La información ha sido actualizada con éxito', 'success');
            }
            _this.requisicion = updatedDoc;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RequisicionesEditor.prototype.onApplyingNextStep = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.requisicionService.nextStep(args.document.id, args.step.idWorkflowStep, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(args.document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RequisicionesEditor.prototype.onApplyingPreviousStep = function (document) {
        var _this = this;
        this.context.app.showSpinner();
        this.requisicionService.previousStep(document.id, null)
            .then(function (_) {
            //Volver a cargar documento
            _this.onViewingDocument(document.id);
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RequisicionesEditor.prototype.onTabSelected = function (args) {
        if (args.heading) {
            //Al seleccionar la pestaña de historial, realizar carga de información
            if (args.heading == 'Historial') {
                this.loadHistory(this.requisicion.identity);
            }
            //Actualizar controles de wijmo
            wijmo_1.Control.invalidateAll();
        }
    };
    RequisicionesEditor.prototype.onCancelingEdit = function () {
        this.location.back();
    };
    ///////////// DETALLE DEL DOCUMENTO /////////////////////////
    RequisicionesEditor.prototype.onAddingDetail = function () {
        this.detailsEditor.detail = new requisicion_detail_1.RequisicionDetail();
        this.detailsEditor.show();
    };
    RequisicionesEditor.prototype.onEditingDetail = function (detail) {
        this.detailsEditor.detail = detail;
        this.detailsEditor.show();
    };
    RequisicionesEditor.prototype.onDeletingDetail = function (detail) {
        this.detailsList.deleteItem(detail);
    };
    RequisicionesEditor.prototype.onListItemsUpdated = function (updatedDetails) {
        this.requisicion.details = updatedDetails;
    };
    RequisicionesEditor.prototype.onSavingDetail = function (detail) {
        this.detailsList.updateItem(detail);
    };
    RequisicionesEditor.prototype.loadCentrales = function () {
        var _this = this;
        //this.centralService.loadListByUser(this.context.app.defaultSite.identity)
        //    .then(items => this.centrales = items)
        //    .catch(error => this.handleError(error));
        this.centralService.loadSecurityContext(this.context.app.defaultCompany.identity)
            .then(function (items) {
            _this.securityContext = items;
            var result = _(_this.securityContext).groupBy('idCentral').transform(function (result, current) {
                result.push({
                    id: current[0].idCentral,
                    nombre: current[0].central,
                });
            }, []).value();
            _this.centrales = result;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    RequisicionesEditor.prototype.loadCentrosRecepcion = function (idCentral) {
        //this.centroRecepcionService.loadListByDepartamentoAndUser(idDepartamento, this.context.app.defaultSite.identity)
        //    .then(items => this.centrosRecepcion = items)
        //    .catch(error => this.handleError(error));
        var result = _(this.securityContext.filter(function (item) { return item.idCentral == idCentral; })).groupBy('idCentroRecepcion').transform(function (result, current) {
            result.push({
                id: current[0].idCentroRecepcion,
                nombre: current[0].centroRecepcion,
            });
        }, []).value();
        this.centrosRecepcion = result;
    };
    RequisicionesEditor.prototype.loadDepartamentos = function (idCentroRecepcion) {
        var _this = this;
        //this.departamentoService.loadListByCentralUser(idCentral, this.context.app.defaultSite.identity)
        //    .then(items => this.departamentos = items)
        //    .catch(error => this.handleError(error));
        var result = _(this.securityContext.filter(function (item) { return item.idCentral == _this.requisicion.idCentral && item.idCentroRecepcion == idCentroRecepcion; })).groupBy('idDepartamento').transform(function (result, current) {
            result.push({
                id: current[0].idDepartamento,
                nombre: current[0].departamento,
            });
        }, []).value();
        this.departamentos = result;
    };
    //Handlers
    RequisicionesEditor.prototype.onArticuloChanged = function (articulo) {
        this.articulo = articulo;
        this.loadUnidadesMedida(this.articulo.articuloStock.unidadMedida.idUnidadMedidaTipo);
        //this.articuloService.getDetailByID(item.id)
        //    .then(info => {
        //        this.articulo = info;
        //        this.loadUnidadesMedida(this.articulo.articuloStock.unidadMedida.idUnidadMedidaTipo);
        //    })
        //    .catch(error => this.handleError(error));        
    };
    RequisicionesEditor.prototype.loadUnidadesMedida = function (idTipoUnidad) {
        var _this = this;
        //Si el articulo esta controlado por series, no se puede cambiar la unidad de medida, por lo tanto solo se debe utilizar la unidad de medida el articulo,
        //en caso contrario, cargar lista de unidades de medida del mismo tipo
        if (this.articulo.articuloStock.manejaSeries) {
            var unidadArticulo = this.articulo.articuloStock.unidadMedida;
            var newUnidad = {
                id: unidadArticulo.identity, codigo: unidadArticulo.code, idUnidadMedidaTipo: unidadArticulo.idUnidadMedidaTipo, base: unidadArticulo.base,
                factor: unidadArticulo.factor, fraccionable: unidadArticulo.fraccionable, paquete: unidadArticulo.paquete, activo: true
            };
            var newUnidades = [];
            newUnidades.push(newUnidad);
            this.unidadesMedida = newUnidades;
            this.requisicion.idUnidadMedida = unidadArticulo.identity;
        }
        else {
            this.unidadMedidaService.loadList(idTipoUnidad)
                .then(function (unidadesMedida) {
                _this.unidadesMedida = unidadesMedida;
                _this.requisicion.idUnidadMedida = _this.articulo.idUnidadMedida;
            })
                .catch(function (error) { return _this.handleError(error); });
        }
    };
    var RequisicionesEditor_1;
    __decorate([
        core_1.ViewChild('detailsList'),
        __metadata("design:type", editors_1.EditableListComponent)
    ], RequisicionesEditor.prototype, "detailsList", void 0);
    __decorate([
        core_1.ViewChild('detailsEditor'),
        __metadata("design:type", requisiciones_detail_editor_1.RequisicionDetailEditor)
    ], RequisicionesEditor.prototype, "detailsEditor", void 0);
    RequisicionesEditor = RequisicionesEditor_1 = __decorate([
        core_1.Component({
            selector: 'compras-requisiciones-editor',
            template: "\n      <form [formGroup]=\"documentForm\">\n          <azteca-document-editor #documentEditor\n                                         [title]=\"'Requisiciones'\"\n                                         [document]=\"requisicion\"\n                                         [valid]=\"valid\"\n                                         (configureDocument)=\"onConfigureDocument($event)\"\n                                         (creatingDocument)=\"onCreatingDocument()\"\n                                         (viewingDocument)=\"onViewingDocument($event)\"\n                                         (cloningDocument)=\"onCloningDocument($event)\"\n                                         (savingDocument)=\"onSavingDocument($event)\"\n                                         (loadingDocument)=\"onLoadingDocument($event)\"\n                                         (applyingNextStep)=\"onApplyingNextStep($event)\"\n                                         (menuItemClick)=\"onMenuItemClick($event)\">\n\n              <!------------------- Menu de acciones adicionales --------------------->\n\n              <!------------------- Controles del editor ----------------------------->\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\" (select)=\"onTabSelected($event)\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Tipo:'\">\n                                          <az-combobox formControlName=\"idTipoRequisicion\"\n                                                       [(ngModel)]=\"requisicion.idTipoRequisicion\"\n                                                       [items]=\"requisicionesTipo\"\n                                                       [displayMember]=\"'nombre'\"\n                                                       [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Central:'\">\n                                          <az-combobox formControlName=\"idCentral\"\n                                                          [(ngModel)]=\"requisicion.idCentral\"\n                                                          [items]=\"centrales\"\n                                                          [displayMember]=\"'nombre'\"\n                                                          [valueMember]=\"'id'\"\n                                                          (selectedItemChanged)=\"loadCentrosRecepcion($event)\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Centro de Recepci\u00F3n:'\">\n                                          <az-combobox formControlName=\"idCentroRecepcion\"\n                                                          [(ngModel)]=\"requisicion.idCentroRecepcion\"\n                                                          [items]=\"centrosRecepcion\"\n                                                          [displayMember]=\"'nombre'\"\n                                                          [valueMember]=\"'id'\"\n                                                          (selectedItemChanged)=\"loadDepartamentos($event)\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Departamento:'\">\n                                          <az-combobox formControlName=\"idDepartamento\"\n                                                          [(ngModel)]=\"requisicion.idDepartamento\"\n                                                          [items]=\"departamentos\"\n                                                          [displayMember]=\"'nombre'\"\n                                                          [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Articulo/Servicio:'\">\n                                          <az-combobox formControlName=\"articuloServicio\"\n                                                          [(ngModel)]=\"articuloServicio\"\n                                                          [items]=\"articuloServicioItems\"\n                                                          [displayMember]=\"'nombre'\"\n                                                          [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n                                                        \n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Cantidad:'\">\n                                          <az-input-number formControlName=\"cantidad\"\n                                                              [(ngModel)]=\"requisicion.cantidad\">\n                                          </az-input-number>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Articulo:'\" *ngIf=\"articuloServicio=='A'\">\n                                          <purchasing-articulo-selector formControlName=\"idArticulo\"\n                                                                          [(ngModel)]=\"requisicion.idArticulo\"\n                                                                          (selectedItemChanged)=\"onArticuloChanged($event)\"\n                                                                          (articuloUpdated)=\"onArticuloChanged($event)\">\n                                          </purchasing-articulo-selector>\n                                      </azteca-form-field>\n                                  </div>\n\n                                  <div class=\"col-12 col-md-4\">\n                                      <azteca-form-field [label]=\"'Unidad de medida:'\" *ngIf=\"articuloServicio=='A'\">\n                                          <az-combobox formControlName=\"idUnidadMedida\"\n                                                          [(ngModel)]=\"idUnidadMedida\"\n                                                          [items]=\"unidadesMedida\"\n                                                          [displayMember]=\"'nombre'\"\n                                                          [valueMember]=\"'id'\">\n                                          </az-combobox>\n                                      </azteca-form-field>\n                                  </div>\n\n\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Servicio:'\" *ngIf=\"articuloServicio=='S'\">\n                                          <purchasing-servicios-selector formControlName=\"idServicio\"\n                                                                          [(ngModel)]=\"requisicion.idServicio\">\n                                          </purchasing-servicios-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <az-panel [header]=\"'Presupuesto'\" type=\"success\" *ngIf=\"!departamento.tipoPresupuesto=='N'\">\n                                  <div class=\"row\">\n                                      <div class=\"col-12 col-md-6\">\n                                          <azteca-form-field [label]=\"'Presupuesto:'\" *ngIf=\"!departamento.tipoPresupuesto=='N'\">\n                                              <az-combobox formControlName=\"idPresupuesto\"\n                                                              [(ngModel)]=\"requisicion.idPresupuesto\"\n                                                              [items]=\"presupuestos\"\n                                                              [displayMember]=\"'nombre'\"\n                                                              [valueMember]=\"'id'\">\n                                              </az-combobox>\n                                          </azteca-form-field>\n                                      </div>\n                                      <div class=\"col-12 col-md-6\">\n                                          <azteca-form-field [label]=\"'Categoria Presupuestal:'\" *ngIf=\"departamento.tipoPresupuesto=='C'\">\n                                              <az-combobox formControlName=\"idCategoriaPresupuestal\"\n                                                              [(ngModel)]=\"requisicion.idCategoriaPresupuestal\"\n                                                              [items]=\"presupuesto.details\"\n                                                              [displayMember]=\"'categoriaPresupuestal.nombre'\"\n                                                              [valueMember]=\"'idCategoriaPresupuestal'\">\n                                              </az-combobox>\n                                          </azteca-form-field>\n                                      </div>\n                                  </div>\n                              </az-panel>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Observaciones:'\">\n                                          <az-textarea formControlName=\"observaciones\"\n                                                          [(ngModel)]=\"requisicion.observaciones\">\n                                          </az-textarea>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                          </tab>\n                   \n                          <tab heading=\"Historial\" (select)=\"onTabSelected($event)\" [disabled]=\"requisicion.identity==''\">\n                              <document-history [history]=\"history\"></document-history>\n                          </tab>\n                      </tabset>\n\n                  </div>\n              </div>\n          </azteca-document-editor>\n      </form>\n\n      <compras-requisicion-detail-editor #detailsEditor                                     \n                                           (savingItem)=\"onSavingDetail($event)\">\n\n      </compras-requisicion-detail-editor>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return RequisicionesEditor_1; })
                },
                {
                    provide: core_2.DocumentService, useExisting: requisicion_service_1.RequisicionService
                }
            ]
        }),
        __metadata("design:paramtypes", [core_2.Context,
            router_1.Router,
            router_1.ActivatedRoute,
            common_1.Location,
            forms_1.FormBuilder,
            core_2.DocumentTypeService,
            requisicion_service_1.RequisicionService,
            departamento_service_1.DepartamentoService,
            centro_recepcion_service_1.CentroRecepcionService,
            inventory_1.UnidadMedidaService,
            articulo_service_1.ArticuloService,
            presupuesto_service_1.PresupuestoService,
            central_service_1.CentralService])
    ], RequisicionesEditor);
    return RequisicionesEditor;
}(editors_1.DocumentEditor));
exports.RequisicionesEditor = RequisicionesEditor;
