import { CatalogInfo, CatalogItem, UsuarioInfo } from 'framework3/core';
import { DomicilioInfo } from 'framework3/general';
import { ContribuyenteInfo } from '../../accounting';
import { BeneficiarioInfo } from '../../treasury';
export declare class ProveedorInfo extends CatalogInfo {
    idTipoProveedor: number;
    nombre: string;
    domicilio: DomicilioInfo;
    telefono: string;
    fax: string;
    celular: string;
    correo: string;
    paginaWeb: string;
    diasAnticipo: number;
    porcentajeAnticipo: number;
    idCuenta: number;
    idContribuyente: number;
    idBeneficiario: number;
    usuario: UsuarioInfo;
    contribuyente: ContribuyenteInfo;
    beneficiario: BeneficiarioInfo;
    constructor();
}
export declare class ProveedorItem implements CatalogItem {
    id: number;
    codigo: string;
    nombre: string;
    rfc: string;
    correo: string;
    telefono: string;
    domicilio: string;
    poblacion: string;
    cp: string;
    idBeneficiario: number;
    idContribuyente: number;
    activo: boolean;
    estatus?: string;
    selected?: boolean;
}
export declare class ProveedorArticulo {
    idProveedorArticulo: number;
    idProveedor: number;
    idZonaCompra: number;
    idArticulo: number;
    idDivisa: number;
    costo: number;
    diasCredito: number;
    diasEntrega: number;
    porcAnticipo: number;
    idUnidadMedida: number;
    porcDescuento1: number;
    porcDescuento2: number;
    porcDescuento3: number;
    porcDescuento4: number;
    porcDescuento5: number;
    predeterminado: number;
    userCreate: number;
    userUpdate: number;
    lastUpdate: Date;
    createDate: Date;
    constructor();
}
export declare class ProveedorServicio {
    idProveedorServicio: number;
    idProveedor: number;
    idZonaCompra: number;
    idServicio: number;
    idDivisa: number;
    costo: number;
    diasCredito: number;
    diasEntrega: number;
    porcAnticipo: number;
    porcDescuento1: number;
    porcDescuento2: number;
    porcDescuento3: number;
    porcDescuento4: number;
    porcDescuento5: number;
    predeterminado: number;
    userCreate: number;
    userUpdate: number;
    lastUpdate: Date;
    createDate: Date;
    constructor();
}
export declare class PreRegistro {
    idPreRegistro: number;
    rfc: string;
    nombreComercial: string;
    razonSocial: string;
    correo: string;
    password: string;
}
