"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
//////////////////////////// Guards //////////////////////////////////
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//////////////////////////// Catalogos ////////////////////////////////
var empresas_manager_1 = require("./catalogs/empresas.manager");
var empresas_editor_1 = require("./catalogs/empresas.editor");
var centrales_manager_1 = require("./catalogs/centrales.manager");
var centrales_editor_1 = require("./catalogs/centrales.editor");
var departamentos_manager_1 = require("./catalogs/departamentos.manager");
var departamentos_editor_1 = require("./catalogs/departamentos.editor");
var centros_recepcion_manager_1 = require("./catalogs/centros-recepcion.manager");
var centros_recepcion_editor_1 = require("./catalogs/centros-recepcion.editor");
var centros_costo_manager_1 = require("./catalogs/centros-costo.manager");
var centros_costo_editor_1 = require("./catalogs/centros-costo.editor");
var proveedores_manager_1 = require("./catalogs/proveedores.manager");
var proveedores_editor_1 = require("./catalogs/proveedores.editor");
var servicios_manager_1 = require("./catalogs/servicios.manager");
var zonas_compra_manager_1 = require("./catalogs/zonas-compra.manager");
var zonas_compra_editor_1 = require("./catalogs/zonas-compra.editor");
var articulos_manager_1 = require("./catalogs/articulos.manager");
var articulos_editor_1 = require("./catalogs/articulos.editor");
var proveedor_articulo_component_1 = require("./components/proveedor-articulo.component");
var producto_proveedor_component_1 = require("./components/producto-proveedor.component");
///////////////////////////// Documentos //////////////////////////////
var almacen_digital_component_1 = require("./documents/almacen-digital.component");
var grupo_requisiciones_manager_1 = require("./documents/grupo-requisiciones.manager");
var grupo_requisiciones_editor_1 = require("./documents/grupo-requisiciones.editor");
var requisiciones_manager_1 = require("./documents/requisiciones.manager");
var requisiciones_editor_1 = require("./documents/requisiciones.editor");
var ordenes_manager_1 = require("./documents/ordenes.manager");
var ordenes_editor_1 = require("./documents/ordenes.editor");
var presupuestos_manager_1 = require("./documents/presupuestos.manager");
var presupuestos_editor_1 = require("./documents/presupuestos.editor");
var recepciones_manager_1 = require("./documents/recepciones.manager");
var recepciones_editor_1 = require("./documents/recepciones.editor");
//////////////////////////// Mantenimientos ////////////////////////////////
var proveedores_registrar_maintenance_1 = require("./maintenances/proveedores-registrar.maintenance");
///////////////////////////// Parts //////////////////////////////
var validacion_cfd_component_1 = require("./parts/validacion-cfd.component");
var central_miembros_component_1 = require("./parts/central-miembros.component");
var central_departamentos_component_1 = require("./parts/central-departamentos.component");
var centros_recepcion_miembros_component_1 = require("./parts/centros-recepcion-miembros.component");
var departamentos_miembros_component_1 = require("./parts/departamentos-miembros.component");
var departamentos_centros_recepcion_component_1 = require("./parts/departamentos-centros-recepcion.component");
var index_1 = require("./index");
var categorias_presupuestales_manager_1 = require("./catalogs/categorias-presupuestales.manager");
var categorias_presupuestales_editor_1 = require("./catalogs/categorias-presupuestales.editor");
var components_1 = require("./components");
///////////////////////////// Rutas /////////////////////////////////
var routes = [
    {
        path: '',
        canActivateChild: [core_2.AuthGuard],
        children: [
            // CATALOGS
            { path: 'empresas-compras/:proceso', component: empresas_manager_1.EmpresasManager },
            { path: 'empresas-compras/:proceso/:id', component: empresas_editor_1.EmpresasEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'centrales/:proceso', component: centrales_manager_1.CentralesManager },
            { path: 'centrales/:proceso/:id', component: centrales_editor_1.CentralesEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'centrales/:proceso/:id/members', component: central_miembros_component_1.CentralMiembrosComponent },
            { path: 'centrales/:proceso/:id/departamentos', component: central_departamentos_component_1.CentralDepartamentosComponent },
            { path: 'departamentos/:proceso', component: departamentos_manager_1.DepartamentosManager },
            { path: 'departamentos/:proceso/:id', component: departamentos_editor_1.DepartamentosEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'departamentos/:proceso/:id/members', component: departamentos_miembros_component_1.DepartamentosMiembrosComponent },
            { path: 'departamentos/:proceso/:id/centros-recepcion', component: departamentos_centros_recepcion_component_1.DepartamentosCentrosRecepcionComponent },
            //{ path: 'departamentos/:proceso/:id/centros-costo', component: DepartamentosCentrosRecepcionComponent },
            { path: 'centros-recepcion/:proceso', component: centros_recepcion_manager_1.CentrosRecepcionManager },
            { path: 'centros-recepcion/:proceso/:id', component: centros_recepcion_editor_1.CentrosRecepcionEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'centros-recepcion/:proceso/:id/members', component: centros_recepcion_miembros_component_1.CentrosRecepcionMiembrosComponent },
            { path: 'centros-costo/:proceso', component: centros_costo_manager_1.CentrosCostoManager },
            { path: 'centros-costo/:proceso/:id', component: centros_costo_editor_1.CentrosCostoEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'proveedores/:proceso', component: proveedores_manager_1.ProveedoresManager },
            { path: 'proveedores/:proceso/:id', component: proveedores_editor_1.ProveedoresEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'zonas-compra/:proceso', component: zonas_compra_manager_1.ZonasCompraManager },
            { path: 'zonas-compra/:proceso/:id', component: zonas_compra_editor_1.ZonasCompraEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'articulos/:proceso', component: articulos_manager_1.ArticulosManager },
            { path: 'articulos/:proceso/:id', component: articulos_editor_1.ArticulosEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'proveedor-articulo/:proceso/:id/:idProveedor/:idArticulo/:idZona/:editProveedor/:editArticulo/:editZona', component: proveedor_articulo_component_1.ProveedorArtioculoComponent, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'proveedor-producto/:proceso', component: index_1.ProveedorProductoComponent },
            { path: 'producto-proveedor/:proceso', component: producto_proveedor_component_1.ProductoProveedorComponent },
            { path: 'servicios-compras/:proceso', component: servicios_manager_1.ServiciosManager },
            { path: 'servicios-compras/:proceso/:id', component: servicios_manager_1.ServiciosManager, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'proveedor-servicio/:proceso/:id/:idProveedor/:idServicio/:idZona/:editProveedor/:editServicio/:editZona', component: components_1.ProveedorServicioComponent, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'categorias-presupuestales/:proceso', component: categorias_presupuestales_manager_1.CategoriasPresupuestalesManager },
            { path: 'categorias-presupuestales/:proceso/:id', component: categorias_presupuestales_editor_1.CategoriasPresupuestalesEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'presupuestos/:proceso', component: presupuestos_manager_1.PresupuestosManager },
            { path: 'presupuestos/:proceso/:id', component: presupuestos_editor_1.PresupuestosEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            //DOCUMENTS
            { path: 'almacen-digital/:proceso', component: almacen_digital_component_1.AlmacenDigitalComponent },
            //PARTS
            { path: 'almacen-digital/:proceso/upload', component: validacion_cfd_component_1.ValidacionCFDComponent },
            { path: 'grupo-requisiciones/:proceso', component: grupo_requisiciones_manager_1.GrupoRequisicionesManager },
            { path: 'grupo-requisiciones/:proceso/:id', component: grupo_requisiciones_editor_1.GrupoRequisicionesEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'requisiciones/:proceso', component: requisiciones_manager_1.RequisicionesManager },
            { path: 'requisiciones/:proceso/:id', component: requisiciones_editor_1.RequisicionesEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'requisiciones/:proceso/:idGrupoRequisiciones/:id', component: requisiciones_editor_1.RequisicionesEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'ordenes-compra/:proceso', component: ordenes_manager_1.OrdenesManager },
            { path: 'ordenes-compra/:proceso/:id', component: ordenes_editor_1.OrdenesEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'recepciones/:proceso', component: recepciones_manager_1.RecepcionesManager },
            { path: 'recepciones/:proceso/:id/:idCentroRecepcion/:idOrden', component: recepciones_editor_1.RecepcionesEditor, canDeactivate: [editors_1.EditorDeactivateGuard] },
            { path: 'proveedores-registrar/:proceso', component: proveedores_registrar_maintenance_1.ProveedoresRegistrar },
        ]
    },
];
var PurchasingRoutingModule = /** @class */ (function () {
    function PurchasingRoutingModule() {
    }
    PurchasingRoutingModule = __decorate([
        core_1.NgModule({
            imports: [
                router_1.RouterModule.forChild(routes)
            ],
            exports: [
                router_1.RouterModule
            ]
        })
    ], PurchasingRoutingModule);
    return PurchasingRoutingModule;
}());
exports.PurchasingRoutingModule = PurchasingRoutingModule;
