"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
//Frameworks
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var forms_1 = require("@angular/forms");
var common_1 = require("@angular/common");
//Azteca Kernel
var core_2 = require("framework3/core");
var editors_1 = require("framework3/editors");
//Features
var empleado_service_1 = require("../services/empleado.service");
var empleado_1 = require("../models/empleado");
var adamnomina_1 = require("../models/adamnomina");
var EmpleadosEditor = /** @class */ (function (_super) {
    __extends(EmpleadosEditor, _super);
    //
    function EmpleadosEditor(router, route, formBuilder, changeDetector, context, location, empleadoService) {
        var _this = _super.call(this, context, router, route, changeDetector) || this;
        _this.router = router;
        _this.route = route;
        _this.formBuilder = formBuilder;
        _this.changeDetector = changeDetector;
        _this.context = context;
        _this.location = location;
        _this.empleadoService = empleadoService;
        _this.empleado = new empleado_1.EmpleadoInfo();
        _this.adamNomina = new adamnomina_1.AdamNominaInfo();
        _this.catalogForm = formBuilder.group({
            'codigo': ['', forms_1.Validators.required],
            'nombre': ['', forms_1.Validators.required],
            'apPaterno': ['', forms_1.Validators.required],
            'apMaterno': ['', forms_1.Validators.required],
            'sexo': [''],
            'fechaNacimiento': [''],
            'fechaIngreso': [''],
            'correo': [''],
            'imss': [''],
            'rfc': [''],
            'curp': [''],
            'titulo': [''],
            'calle': [''],
            'cruce1': [''],
            'cruce2': [''],
            'numExt': [''],
            'numInt': [''],
            'colonia': [''],
            'poblacion': [''],
            'turno': [''],
            'plaza': [''],
            'cp': [''],
            'razonSocial': ['']
        });
        return _this;
    }
    EmpleadosEditor_1 = EmpleadosEditor;
    ///////////////////////// METODOS ///////////////////////////////////////
    ///////////////////////// HANDLERS ///////////////////////////////////////
    EmpleadosEditor.prototype.onConfigureCatalog = function (options) {
        this.autogeneratedCode = options.codigoAutogenerado;
    };
    EmpleadosEditor.prototype.onCreatingItem = function () {
    };
    EmpleadosEditor.prototype.onViewingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.empleadoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.empleado = info;
            _this.setReadonlyMode();
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpleadosEditor.prototype.onCloningItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        //
        this.empleadoService.clone(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.empleado = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpleadosEditor.prototype.onLoadingItem = function (id) {
        var _this = this;
        this.context.app.showSpinner();
        this.empleadoService.getDetailByID(id)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.empleado = info;
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpleadosEditor.prototype.onSavingItem = function (args) {
        var _this = this;
        this.context.app.showSpinner();
        this.volcarDomicilio();
        this.empleadoService.update(this.empleado)
            .then(function (info) {
            _this.context.app.hideSpinner();
            _this.empleado = info;
            _this.reset();
            if (args.closeEditor)
                _this.location.back();
            else
                _this.showAlert('La información ha sido actualizada con éxito', 'success');
        })
            .catch(function (error) { return _this.handleError(error); });
    };
    EmpleadosEditor.prototype.volcarDomicilio = function () {
        this.empleado.contribuyente.domicilio.calle = this.empleado.persona.domicilio.calle;
        this.empleado.contribuyente.domicilio.numeroExterior = this.empleado.persona.domicilio.numeroExterior;
        this.empleado.contribuyente.domicilio.numeroInterior = this.empleado.persona.domicilio.numeroInterior;
        this.empleado.contribuyente.domicilio.codigoPostal = this.empleado.persona.domicilio.codigoPostal;
        this.empleado.contribuyente.domicilio.colonia = this.empleado.persona.domicilio.colonia;
        this.empleado.contribuyente.domicilio.idPoblacion = this.empleado.persona.domicilio.idPoblacion;
        this.empleado.contribuyente.rfc = this.empleado.rfc;
        this.empleado.contribuyente.correo = this.empleado.persona.correo;
        this.empleado.contribuyente.idUsoCFDI = 22; //Manualmente le enviamos "Por definir al USOCFDI"
    };
    var EmpleadosEditor_1;
    EmpleadosEditor = EmpleadosEditor_1 = __decorate([
        core_1.Component({
            selector: 'rh-empleados-editor',
            template: "\n      <form [formGroup]=\"catalogForm\">\n\n          <azteca-catalog-editor #catalogEditor\n                                 [title]=\"'Empleado'\"\n                                 [info]=\"empleado\"\n                                 [valid]=\"valid\"\n                                 (configureCatalog)=\"onConfigureCatalog($event)\"\n                                 (creatingItem)=\"onCreatingItem()\"\n                                 (viewingItem)=\"onViewingItem($event)\"\n                                 (cloningItem)=\"onCloningItem($event)\"\n                                 (savingItem)=\"onSavingItem($event)\"\n                                 (loadingItem)=\"onLoadingItem($event)\">\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <azteca-form-field [label]=\"'C\u00F3digo:'\">\n                          <catalog-code formControlName=\"codigo\" [(ngModel)]=\"empleado.code\" [automatic]=\"autogeneratedCode\"></catalog-code>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-6\">\n                      <azteca-form-field [label]=\"'Nombre:'\">\n                          <az-textbox formControlName=\"nombre\" [(ngModel)]=\"empleado.persona.nombre\"></az-textbox>\n                      </azteca-form-field>\n                      <azteca-form-field [label]=\"'Ap. Paterno:'\">\n                          <az-textbox formControlName=\"apPaterno\" [(ngModel)]=\"empleado.persona.apellidoPaterno\"></az-textbox>\n                      </azteca-form-field>\n                      <azteca-form-field [label]=\"'Ap. Materno:'\">\n                          <az-textbox formControlName=\"apMaterno\" [(ngModel)]=\"empleado.persona.apellidoMaterno\"></az-textbox>\n                      </azteca-form-field>\n                  </div>\n              </div>\n\n              <div class=\"row\">\n                  <div class=\"col-12 col-md-10\">\n                      <tabset>\n                          <tab heading=\"Generales\">\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Sexo:'\">\n                                          <select formControlName=\"sexo\" class=\"form-control\" [(ngModel)]=\"empleado.sexo\">\n                                              <option [value]=\"'M'\">Masculino</option>\n                                              <option [value]=\"'F'\">Femenino</option>\n                                          </select>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Fecha Nacimiento:'\">\n                                          <az-input-date formControlName=\"fechaNacimiento\" [(ngModel)]=\"empleado.fechaNacimiento\"></az-input-date>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Fecha Ingreso:'\">\n                                          <az-input-date formControlName=\"fechaIngreso\" [(ngModel)]=\"empleado.fechaIngreso\"></az-input-date>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Correo:'\">\n                                          <az-textbox formControlName=\"correo\" [(ngModel)]=\"empleado.persona.correo\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'Num. IMSS:'\">\n                                          <az-textbox formControlName=\"imss\" [(ngModel)]=\"empleado.imss\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'RFC:'\">\n                                          <az-textbox formControlName=\"rfc\" [(ngModel)]=\"empleado.rfc\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'CURP:'\">\n                                          <az-textbox formControlName=\"curp\" [(ngModel)]=\"empleado.curp\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-6\">\n                                      <azteca-form-field [label]=\"'T&iacute;tulo:'\">\n                                          <az-textbox formControlName=\"titulo\" [(ngModel)]=\"empleado.titulo\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                          </tab>\n\n                          <tab heading=\"Domicilio\">\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Calle:'\">\n                                          <az-textbox formControlName=\"calle\" [(ngModel)]=\"empleado.persona.domicilio.calle\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Cruce:'\">\n                                          <az-textbox formControlName=\"cruce1\" [(ngModel)]=\"empleado.persona.domicilio.cruce1\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Cruce:'\">\n                                          <az-textbox formControlName=\"cruce2\" [(ngModel)]=\"empleado.persona.domicilio.cruce2\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-5\">\n                                      <azteca-form-field [label]=\"'N&uacute;mero Exterior:'\">\n                                          <az-textbox formControlName=\"numExt\" [(ngModel)]=\"empleado.persona.domicilio.numeroExterior\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                                  <div class=\"col-12 col-md-5\">\n                                      <azteca-form-field [label]=\"'N&uacute;mero Interior:'\">\n                                          <az-textbox formControlName=\"numInt\" [(ngModel)]=\"empleado.persona.domicilio.numeroInterior\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-5\">\n                                      <azteca-form-field [label]=\"'C&oacute;digo postal:'\">\n                                          <az-textbox formControlName=\"cp\" [(ngModel)]=\"empleado.persona.domicilio.codigoPostal\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                              <div class=\"row\">\n                                  <div class=\"col-12 col-md-10\">\n                                      <azteca-form-field [label]=\"'Colonia:'\">\n                                          <az-textbox formControlName=\"colonia\" [(ngModel)]=\"empleado.persona.domicilio.colonia\"></az-textbox>\n                                      </azteca-form-field>\n                                      <azteca-form-field [label]=\"'Poblaci&oacute;n:'\">\n                                          <poblacion-selector formControlName=\"poblacion\" [(ngModel)]=\"empleado.persona.domicilio.idPoblacion\"></poblacion-selector>\n                                      </azteca-form-field>\n                                  </div>\n                              </div>\n                          </tab>\n\n                          <tab heading=\"Empresa\">\n                              <azteca-form-field [label]=\"'Turno:'\">\n                                  <rh-turno-selector formControlName=\"turno\"\n                                                     [(ngModel)]=\"empleado.idTurno\"\n                                                     [enabled]=\"true\">\n                                  </rh-turno-selector>\n                              </azteca-form-field>\n\n                              <azteca-form-field [label]=\"'Plaza:'\">\n                                  <rh-plaza-selector formControlName=\"plaza\"\n                                                     [(ngModel)]=\"empleado.idPlaza\"\n                                                     [enabled]=\"true\"></rh-plaza-selector>\n                              </azteca-form-field>\n                          </tab>\n\n                          <tab heading=\"Facturaci\u00F3n\">\n\n                              <az-panel>\n\n                                  <div class=\"col-10 col-md-8\">\n                                      <azteca-form-field [label]=\"'Raz\u00F3n Social:'\">\n                                          <az-textbox formControlName=\"razonSocial\" [(ngModel)]=\"empleado.contribuyente.razonSocial\"></az-textbox>\n                                      </azteca-form-field>\n                                  </div>\n\n                              </az-panel>\n\n                          </tab>\n\n                      </tabset>\n                  </div>\n              </div>\n\n          </azteca-catalog-editor>\n      </form>\n    ",
            providers: [
                {
                    provide: core_2.BaseComponent, useExisting: core_1.forwardRef(function () { return EmpleadosEditor_1; })
                },
                {
                    provide: core_2.CatalogService, useExisting: empleado_service_1.EmpleadoService
                }
            ]
        }),
        __metadata("design:paramtypes", [router_1.Router, router_1.ActivatedRoute, forms_1.FormBuilder, core_1.ChangeDetectorRef,
            core_2.Context, common_1.Location, empleado_service_1.EmpleadoService])
    ], EmpleadosEditor);
    return EmpleadosEditor;
}(editors_1.CatalogEditor));
exports.EmpleadosEditor = EmpleadosEditor;
